;*******************************************Handle Block Explosion
;*
;*	This functions handles a block explosion(when a block explodes)
;*
;*	Input	d6=the bexp explosion # in the array
;*
;*********

bomberd4@0000:
handle_bexp:
	bsr	learn_bexp
	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_bexp
	move.w	s,(a4)
	rts

learn_bexp:
	lea	bomberd2::bexp_x,a0		;Get bexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::bexp_y,a0		;Get bexp d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::bexp_s,a0		;Get bexp d6's s
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s

	sub.w	#8,x
	sub.w	#8,y
	rts

bomberd4@0001:
draw_bexp:
	bsr	learn_bexp
	cmp.w	#1,s			;draw the bexp sprite
	beq		hbe_s1
	cmp.w	#2,s
	beq		hbe_s2
	cmp.w	#3,s
	beq		hbe_s3
	cmp.w	#4,s
	beq		hbe_s4
	cmp.w	#5,s
	beq		hbe_s4
	bra		delete_bexp
hbe_exit:
	rts

hbe_s1:
	move.l	bomberd2::sprite_bexp5,a2
	Draw2ByteSpriteToBufferMaskAFromLib	a2,x,y,#16
	rts

hbe_s2:
	move.l	bomberd2::sprite_bexp4,a2
	Draw2ByteSpriteToBufferMaskAFromLib	a2,x,y,#16
	rts

hbe_s3:
	move.l	bomberd2::sprite_bexp3,a2
	Draw2ByteSpriteToBufferMaskAFromLib	a2,x,y,#16
	rts

hbe_s4:
	move.l	bomberd2::sprite_bexp2,a2
	Draw2ByteSpriteToBufferMaskAFromLib	a2,x,y,#16
	rts

hbe_s5:
	move.l	bomberd2::sprite_bexp1,a2
	Draw2ByteSpriteToBufferMaskAFromLib	a2,x,y,#16
	rts

;*******************************************Delete Block Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the bexp array
;*
;*********
bomberd4@0002:
delete_bexp:

	movem.l	d0/a0-a2,-(a7)

	lea	bomberd2::bexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::bexp_y,a1
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a1,d0.w),a1

	lea	bomberd2::bexp_s,a2
	;move.w  d6,d0
	;mulu.w	#2,d0
	lea	0(a2,d0.w),a2

	move.w	bomberd2::bexpcount,d1
	sub.w	d6,d1
	cmp.w	#0,d1
	beq		dbe_loop_exit
	subq.w	#1,d1

		;this code shifts the array starting at the bexp #
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
dbe_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2

	dbra.w	d1,dbe_loop

dbe_loop_exit:
	subq.w	#1,bomberd2::bexpcount

	movem.l	(a7)+,d0/a0-a2
	rts

;*******************************************Add Block Explosion
;*
;*	This functions adds a block explosion to the bexp array
;*
;*	Input:	x=x coordinate(in squares) of the new bexp
;*		y=y coordinate(in squares) of the new bexp
;*
;*********
bomberd4@0003:
add_bexp:
	movem.l	d0-d4/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	SetBoardL #0

		;check if a bonus should be placed or not
	cmp.w	#1,d2
	bne		add_bexp_no_bonus
	Random  bomberd2::bonus_possibility,d3	;IF (RND*8=1)
	cmp.w	#14,d3
	bcc		add_bexp_no_bonus
	move.w	d3,t
	move.w	#0,tmp2
	bsr		add_bonus
	add_bexp_no_bonus:

	lea	bomberd2::bexp_x,a0		;Set bexp x
	move.w  bomberd2::bexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::bexp_y,a0		;Set bexp y
	move.w  bomberd2::bexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::bexp_s,a0		;Set bexp s
	move.w  bomberd2::bexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#6,d2
	subq.w	#2,d2
	move.w	d2,(a0)

	addq.w	#1,bomberd2::bexpcount

	movem.l	(a7)+,d0-d4/a0
	rts