;*******************************************Load Style
;*
;*	Loads a game style for game operation
;*
;*	Input:	a2=location of style to use
;*	
;*********
load_style:
	move.l	(a2)+,bomberd2::sprite_expblock
	move.l	(a2)+,bomberd2::sprite_unexpblock
	move.l	(a2)+,bomberd2::sprite_back
	move.l	(a2)+,bomberd2::sprite_bexp1
	move.l	(a2)+,bomberd2::sprite_bexp2
	move.l	(a2)+,bomberd2::sprite_bexp3
	move.l	(a2)+,bomberd2::sprite_bexp4
	move.l	(a2)+,bomberd2::sprite_bexp5

	lea	bomberd2::styles,a1

	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	rts

;*******************************************Swap Contexts
;*
;*	Swap the background context for the screen context or vice versa
;*
;*********

activate_background:
	movem.l	d0/a0,-(a7)
	move.l	BKGScreen0,d0
	move.l	d0,DispContext0
	move.l	BKGScreen1,d0
	move.l	d0,DispContext1
	movem.l	(a7)+,d0/a0
	rts

activate_screen:
	movem.l	d0/a0,-(a7)
	move.l	Screen0,d0
	move.l	d0,DispContext0
	move.l	Screen1,d0
	move.l	d0,DispContext1
	movem.l	(a7)+,d0/a0
	rts

;*******************************************Load Map
;*
;*	Loads a map for gameplay
;*
;*	Input:	a0=location of map to use
;*	
;*********
load_map:
	move.w	(a0)+,d0
	move.w	d0,bomberd2::current_style
	jsr	bomberd1::get_style
	bsr	load_style

	move.w	(a0)+,d0
	move.w	d0,bomberd2::map_width
	move.w	(a0)+,d1
	move.w	d1,bomberd2::map_height
	move.w	(a0)+,d2
	move.w	d2,plstart_x
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,bomberd2::plx
	move.w	(a0)+,d2
	move.w	d2,plstart_y
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,bomberd2::ply
	move.w	bomberd2::map_height,d3
	move.w	#0,d1
	subq.w	#1,d3

load_map_loop2:
	move.w	#0,d0
	move.w	bomberd2::map_width,d4
	subq.w	#1,d4
load_map_loop:
	clr.l	d6
	move.w	(a0)+,d6
	cmp.w	#5,d6
	beq	have_random_block_one_half
	cmp.w	#6,d6
	beq	have_random_block_two_thirds
end_have_random_block:
	SetBoard d6
	addq.w	#1,d0
	dbra.w	d4,load_map_loop
	addq.w	#1,d1
	dbra.w	d3,load_map_loop2

	move.w	(a0)+,d0
	move.w	d0,en1
	move.w	(a0)+,d0
	move.w	d0,en2
	move.w	(a0)+,d0
	move.w	d0,en3
	move.w	(a0)+,d0
	move.w	d0,en4
	move.w	(a0)+,d0
	move.w	d0,en5
	bsr	add_monsters
	rts

have_random_block_one_half:
	Random  #2,d6
	bra	end_have_random_block

have_random_block_two_thirds:
	Random  #3,d6
	cmp.w	#2,d6
	bne	end_have_random_block
	move.w	#1,d6
	bra	end_have_random_block

en1	dc.w	0
en2	dc.w	0
en3 dc.w	0
en4 dc.w	0
en5 dc.w	0

;*******************************************Generate Random Monsters
;*
;*	Adds monsters to the map
;*	
;*	Input	en1=num of enemy1
;*		en2=num of enemy2
;*		en3=num of enemy3
;*
;*********
add_monsters:
	move.w	en1,d2
	cmp.w	#20,d0
	bcc	add_monsters_no_enemy1
	cmp.w	#0,d2
	beq	add_monsters_no_enemy1
	subq.w	#1,d2
add_monsters_enemy1_loop:
	Random  bomberd2::map_width,d4
	move.w	d4,d0
	Random  bomberd2::map_height,d4
	move.w	d4,d1
	GetBoard d4
	bsr		check_proximity
	cmp.w	#1,d5
	beq	add_monsters_enemy1_loop
	cmp.w	#0,d4
	bne	add_monsters_enemy1_loop
	jsr	bomberd3::add_enemy1
	SetBoard #45
	dbra.w	d2,add_monsters_enemy1_loop
add_monsters_no_enemy1:

	move.w	en2,d2
	cmp.w	#20,d0
	bcc	add_monsters_no_enemy2
	cmp.w	#0,d2
	beq	add_monsters_no_enemy2
	subq.w	#1,d2
add_monsters_enemy2_loop:
	Random  bomberd2::map_width,d4
	move.w	d4,d0
	Random  bomberd2::map_height,d4
	move.w	d4,d1
	GetBoard d4
	bsr		check_proximity
	cmp.w	#1,d5
	beq	add_monsters_enemy2_loop
	cmp.w	#0,d4
	bne	add_monsters_enemy2_loop
	jsr	bomberd3::add_enemy2
	SetBoard #45
	dbra.w	d2,add_monsters_enemy2_loop
add_monsters_no_enemy2:

	move.w	en3,d2
	cmp.w	#20,d0
	bcc	add_monsters_no_enemy3
	cmp.w	#0,d2
	beq	add_monsters_no_enemy3
	subq.w	#1,d2
add_monsters_enemy3_loop:
	Random  bomberd2::map_width,d4
	move.w	d4,d0
	Random  bomberd2::map_height,d4
	move.w	d4,d1
	GetBoard d4
	bsr		check_proximity
	cmp.w	#1,d5
	beq	add_monsters_enemy3_loop
	cmp.w	#0,d4
	bne	add_monsters_enemy3_loop
	jsr	bomberd3::add_enemy3
	SetBoard #45
	dbra.w	d2,add_monsters_enemy3_loop
add_monsters_no_enemy3:

	move.w	en4,d2
	cmp.w	#20,d0
	bcc	add_monsters_no_enemy4
	cmp.w	#0,d2
	beq	add_monsters_no_enemy4
	subq.w	#1,d2
add_monsters_enemy4_loop:
	Random  bomberd2::map_width,d4
	move.w	d4,d0
	Random  bomberd2::map_height,d4
	move.w	d4,d1
	GetBoard d4
	bsr		check_proximity
	cmp.w	#1,d5
	beq	add_monsters_enemy4_loop
	cmp.w	#0,d4
	bne	add_monsters_enemy4_loop
	jsr	bomberd3::add_enemy4
	SetBoard #45
	dbra.w	d2,add_monsters_enemy4_loop
add_monsters_no_enemy4:

	move.w	en5,d2
	cmp.w	#20,d0
	bcc	add_monsters_no_enemy5
	cmp.w	#0,d2
	beq	add_monsters_no_enemy5
	subq.w	#1,d2
add_monsters_enemy5_loop:
	Random  bomberd2::map_width,d4
	move.w	d4,d0
	Random  bomberd2::map_height,d4
	move.w	d4,d1
	GetBoard d4
	bsr		check_proximity
	cmp.w	#1,d5
	beq	add_monsters_enemy5_loop
	cmp.w	#0,d4
	bne	add_monsters_enemy5_loop
	jsr	bomberd3::add_enemy5
	SetBoard #45
	dbra.w	d2,add_monsters_enemy5_loop
add_monsters_no_enemy5:

	move.w	bomberd2::map_width,d0
	subq.w	#1,d0
remove_enemy_block_loop_x:
	move.w	bomberd2::map_height,d1
	subq.w	#1,d1
remove_enemy_block_loop_y:
	GetBoard d4
	cmp.w	#45,d4
	bne		dont_remove_enemy_block
	SetBoard #0
dont_remove_enemy_block:
	dbra.w	d1,remove_enemy_block_loop_y
	dbra.w	d0,remove_enemy_block_loop_x
	rts

check_proximity:
	movem.l	d3-d4,-(a7)
	move.w	plstart_x,d3
	move.w	d3,d4
	subq.w	#1,d3
	addq.w	#1,d4
	cmp.w	d0,d3
	bhi		check_prox_end_w_good
	cmp.w	d0,d4
	bcs		check_prox_end_w_good
	move.w	plstart_y,d3
	move.w	d3,d4
	subq.w	#1,d3
	addq.w	#1,d4
	cmp.w	d1,d3
	bhi		check_prox_end_w_good
	cmp.w	d1,d4
	bcs		check_prox_end_w_good
	move.w	#1,d5
	movem.l	(a7)+,d3-d4
	rts


check_prox_end_w_good:
	move.w	#0,d5
	movem.l	(a7)+,d3-d4
	rts


;*******************************************Draw Board
;*
;*	This functions is called to draw the entire board from left to right
;*
;*********
draw_board:
		move.w	#0,d0		;FOR x=0 to 12
db_for_x_2:

	move.w	#0,d1			;FOR y=0 to 9
db_for_y_2:

	bsr	draw_board_one

	;GetBoard d4			;IF board(x*10+y)=1 then

	;move.w	d0,d2			;x*9+6
	;mulu.w	#12,d2

	;move.w	d1,d3			;y*9+6
	;mulu.w	#12,d3

	;cmp.w	#1,d4
	;bne	db_end_if_3

	;Draw2ByteSpriteToBuffer	sprite_block0a,sprite_block1a,d2,d3,#12
;db_end_if_3:				;END IF

	;cmp.w	#2,d4			;IF board(x*10+y)=2 then
	;bne	db_end_if_4

	;Draw2ByteSpriteToBuffer	sprite_block0b,sprite_block1b,d2,d3,#12

;db_end_if_4:

	;cmp.w	#0,d4			;IF board(x*10+y)=2 then
	;bne	db_end_if_5

	;Draw2ByteSpriteToBuffer	sprite_back0,sprite_back1,d2,d3,#12

;db_end_if_5:

	addq.w	#1,d1			;NEXT y
	move.w	bomberd2::map_height,d2
	cmp.w	d2,d1
	bne	db_for_y_2	

	addq.w	#1,d0			;NEXT x
	move.w	bomberd2::map_width,d2
	cmp.w	d2,d0
	bne	db_for_x_2

	rts

;*******************************************Draw Board One
;*
;*	This functions is called to draw one piece of the board
;*
;*	Input: 	d0=x position(0-12)
;*		d1=y position(0-9)
;*	
;*********
bomber89@0001:
draw_board_one:
	bsr	activate_background
	movem.l	d2-d4,-(a7)
	move.w	bomberd2::map_width,d2
	cmp.w	d0,d2
	ble	db1_end_if
	move.w	bomberd2::map_height,d3
	cmp.w	d1,d3
	ble	db1_end_if
	GetBoard d4			;IF board(boardpos)<>0 then
	move.w	d0,d2			;x*9+5	(this is the code to 
	mulu.w	#16,d2
	move.w	d1,d3			;y*9+5
	mulu.w	#16,d3
	cmp.w	#3,d4
	beq	db1_draw_back
	cmp.w	#4,d4
	beq	db1_draw_back
	cmp.w	#1,d4
	bne	db1_end_if_0
	move.l	bomberd2::sprite_expblock,a2
	Draw2ByteSpriteToBufferA	a2,d2,d3,#16
	bra	db1_end_if
db1_end_if_0:				;END IF
	cmp.w	#2,d4			;IF board(x*10+y)=2 then
	bne	db1_end_if_2
	move.l	bomberd2::sprite_unexpblock,a2
	Draw2ByteSpriteToBufferA	a2,d2,d3,#16
	bra	db1_end_if
db1_end_if_2:				;END IF
	cmp.w	#0,d4			;IF board(x*10+y)=2 then
	bne	db1_end_if_3
db1_draw_back:
	move.l	bomberd2::sprite_back,a2
	Draw2ByteSpriteToBufferA	a2,d2,d3,#16
	bra	db1_end_if
db1_end_if_3:				;END IF
	;bra	db1_end_if_3
	cmp.w	#9,d4			;IF board(x*10+y)=2 then
	bcs	db1_end_if_4
	cmp.w	#23,d4			;IF board(x*10+y)=2 then
	bhi	db1_end_if_4
	sub.w	#9,d4
	lea	bomberd2::styles,a2
	mulu.w	#4,d4
	add.l		d4,a2
	move.l	(a2),a1
	Draw2ByteSpriteToBufferA	a1,d2,d3,#16
	bra	db1_end_if
db1_end_if_4:
db1_end_if:
	movem.l	(a7)+,d2-d4
	bsr	activate_screen
	rts