	include "bomberd2.h"	;contains the bomberd2 library file
				;for external save games and other things
				;including some functions for enemies and some
				;sprites
	include "bomberd1.h"	;contains some necessary program data
	include "bomberd3.h"	;contains some necessary program data
	include "bomberd4.h"	;contains some necessary program data
	include "doorsos.h"	;includes tios.h and some other important 
				;functions
	include "graphlib.h"	;includes the sprite routines needed for
				;this game
	include	"userlib.h"	;includes key input, boxes, and other things

	xdef    _ti89
	xdef    _comment
	xdef    _main
	xdef	_exit
	xdef	bomber89@0000
	xdef	bomber89@0001
	xdef	bomber89@0002
	xdef	bomber89@0003

	include "macros.asm"		;includes macros needed for the game
	include "variables.asm"		;contains most of the immediate variables and 
					;variable resetting functions

;*******************************************Main
;*
;*	The start of program operation
;*
;********
_main:

    pushm.l    d1-d7/a0-a6
    push.w    #2
    jsr    doorsos::OSTimerRestart
    move.w    #2,(a7)
    jsr    doorsos::OSTimerCurVal
    addq.l    #2,a7
    move.w    d0,d1
    divu    #20,d1
    clr.w    d0
    trap    #1
    move.w    d1,d0
    popm.l        d1-d7/a0-a6

	move.w	d0,saved_APD

	move.w	#5,d0
	jsr	userlib::set_APD

	move.w	#10,current_fade_pos

	SetFont #1	;(MEDIUM)

	bsr	allocate_tables

	cmp.w	#0,d7
	beq	error_noalloc

	jsr	graphlib::gray4	;switches to 4 grayshades mode

	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

startup:

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane

	move.w	#1,tmp
	startup_loop:

		PutGray4SpriteAL bomberd2::title_pic0,bomberd2::title_pic1,#0,#2

		lea		_comment(PC),a2
		lea		10(a2),a2
		SetFont #0
		WriteStrA	#140,#1,#1,a2
		SetFont #1
		WriteStr	#10,#60,#1,name_text
		WriteStr	#74,#60,#1,score_text
		WriteStr	#120,#60,#1,level_text

		move.w	#0,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#58,d1
		move.w	#160,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz
		move.w	#10,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#68,d1
		move.w	#33,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz
		move.w	#74,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#68,d1
		move.w	#103,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz
		move.w	#120,d0			;CALL draw_line(5   ,   5   ,   5+117+1   ,   5)
		move.w	#68,d1
		move.w	#149,d2
		move.w	#2,d3
		move.l	graphlib::plane0,a1
		jsr	graphlib::horiz
		move.l	graphlib::plane1,a1
		jsr	graphlib::horiz

		WriteStr	#10,#48,#1,startup_game_text
		WriteStr	#100,#48,#1,startup_button_text
		cmp.w	#1,tmp
		beq		startup_display_new
		cmp.w	#2,tmp
		beq		startup_display_random
		cmp.w	#3,tmp
		beq		startup_display_about
		cmp.w	#4,tmp
		beq		startup_display_options
		cmp.w	#5,tmp
		beq		startup_display_load
	end_startup_display_selection:

		Fade	#10

		jsr	bomberd2::score_idle_loop		;waits for a key
		cmp	#264,d0
		beq	end_main_code
		cmp	#13,d0
		beq	end_startup_loop
		cmp	#337,d0
		beq	startup_up
		cmp	#340,d0
		beq	startup_down

		bra	end_startup_display_selection

		startup_display_new:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_new_text
			bra end_startup_display_selection

		startup_display_load:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_load_text
			bra end_startup_display_selection

		startup_display_random:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_random_text
			bra end_startup_display_selection

		startup_display_about:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_about_text
			bra end_startup_display_selection

		startup_display_options:
			Fill		#50,#48,#45,#8,#1
			WriteStr	#50,#48,#0,startup_options_text
			bra end_startup_display_selection

		startup_up:
			subq.w	#1,tmp
				cmp.w	#0,tmp
				bne		startup_up_no_roll
					move.w	#5,tmp
				startup_up_no_roll:

				cmp.w	#1,bomberd2::saved_game
				beq		startup_up_no_check_for_saved
				cmp.w	#5,tmp
				bne		startup_up_no_check_for_saved
					move.w	#4,tmp
				startup_up_no_check_for_saved:

			bra	startup_loop

		startup_down:
			addq.w	#1,tmp
				cmp.w	#6,tmp
				bne		startup_down_no_roll
					move.w	#1,tmp
				startup_down_no_roll:

				cmp.w	#1,bomberd2::saved_game
				beq		startup_down_no_check_for_saved
				cmp.w	#5,tmp
				bne		startup_down_no_check_for_saved
					move.w	#1,tmp
				startup_down_no_check_for_saved:

			bra	startup_loop

	end_startup_loop:

		cmp.w	#5,tmp
		beq		open_saved_game
		cmp.w	#4,tmp
		beq		options
		cmp.w	#3,tmp
		beq		about_game
		cmp.w	#2,tmp
		beq		begin_random_game

		Message	starting_text,round_1,#60
		bsr		round_disp_delay
		;bsr		idle_loop
		;cmp	#264,d0
		;beq	startup

		bsr		reset_game_variables

	restart_game:

		bsr	reset_variables
			cmp.w	#0,bomberd2::level
			bne		restart_game_no_random

				Fade	#16

				move.w	#0,d0
				jsr	bomberd1::get_map
				bsr	load_map
				bra		restart_game_random_end

			restart_game_no_random:

				Fade	#16

					move.w	#0,d0
					cmp.w	#4,bomberd2::level
					beq		disp_round_2
					cmp.w	#7,bomberd2::level
					beq		disp_round_3
					cmp.w	#10,bomberd2::level
					beq		disp_round_4
					cmp.w	#13,bomberd2::level
					beq		disp_round_5
					bra		end_disp_round

					disp_round_2:
						Fade	#10
						Message	starting_text,round_2,#60
						;bsr		idle_loop
						bsr		round_disp_delay
						Fade	#16
						bra		end_disp_round

					disp_round_3:
						Fade	#10
						Message	starting_text,round_3,#60
						;bsr		idle_loop
						bsr		round_disp_delay
						Fade	#16
						bra		end_disp_round

					disp_round_4:
						Fade	#10
						Message	starting_text,round_4,#60
						;bsr		idle_loop
						bsr		round_disp_delay
						Fade	#16
						bra		end_disp_round

					disp_round_5:
						Fade	#10
						Message	starting_text,round_5,#60
						;bsr		idle_loop
						bsr		round_disp_delay
						Fade	#16
						bra		end_disp_round

					end_disp_round:
						cmp	#264,d0
						beq	call_check_high_score

				move.w	bomberd2::level,d0
				jsr		bomberd1::get_map
				bsr	load_map

			restart_game_random_end:

begin_main_loop:
	;bsr		change_interrupts

	jsr	graphlib::gray4	;switches to 4 grayshades mode

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane

	bsr	activate_background
	bsr	clear_temp_screen

	bsr	activate_screen

	bsr	clear_temp_screen

	bsr	draw_screen

	PutGray4SpriteMask panel_pic,panel_pic,#%11111111,#130,#1

	bsr	draw_board

	bsr copy_background_to_screen
	bsr	draw_screen

	bsr	draw_sprite		;draw player
	bsr	draw_life		;draw player's life
	bsr	draw_level		;draw current level
	bsr	draw_score		;draw current score

	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

	;move.l	#5,APD_TIMER		;start the game speed equilizing timer

	Fade	#10

scroll_to_bomber_loop:
	bsr		check_scroll
	bsr		draw_screen
	move.l	#3000,d0
wait_scroll_to_bomber_loop:
	nop
	nop
	nop
	nop
	dbra.l	d0,wait_scroll_to_bomber_loop
	cmp.w	#1,s
	beq		scroll_to_bomber_loop

	move.w	#100,disp_level_count
	move.w	#70,disp_level_y

	bra	main_loop
end_main_loop:

end_main_code:

	;bsr	enable_int1

	clr.w	graphlib::choosescreen	;set all graphlib functions to Black and White mode
	;jsr	userlib::idle_loop	;waits for a key

_exit:
	bsr		deallocate_tables
error_noalloc:

	move.w	saved_APD,d0
    pushm.l    d0-d7/a0-a6
    clr.l        d3
    move.w        d0,d3
    move.w        #2,-(a7)
    jsr    doorsos::OSFreeTimer
    mulu        #20,d3
    move.l        d3,-(a7)
    move.w        #2,-(a7)
    jsr    doorsos::OSRegisterTimer
    addq.l        #8,a7
    popm.l        d0-d7/a0-a6

	Fade #10

	jsr		bomberd2::wait_key_release

	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane

	jsr	graphlib::gray2		;restores Black and White mode
	rts

;*******************************************Idle Wait
;*
;*	Wait for the player to enter a key
;*
;*********
idle_loop:

	pushm.l	a0-a6/d1-d7
	move.w		#2,-(a7)
	jsr		doorsos::OSTimerRestart
	clr.w		-(a7)
	clr.l		-(a7)
	jsr		doorsos::GKeyIn
	addq.l		#8,a7
	popm.l		a0-a6/d1-d7
	rts

;idle_loop:
         clr.w    KEY_PRESSED_FLAG         ; Clear keypress counter
         tst.w    KEY_PRESSED_FLAG          ; See if a keypress is stored
         bne.s    idle_loop                ; Continue waiting if not
idle_loop2:
         tst.w    KEY_PRESSED_FLAG          ; See if a keypress is stored
         beq.s    idle_loop2               ; Continue waiting if not
         clr.w    KEY_PRESSED_FLAG          ; Clear keypress counter
         move.w   GETKEY_CODE,d0       ; Read keypress
idle_loop3:
         clr.w    KEY_PRESSED_FLAG          ; Clear keypress counter
         tst.w    KEY_PRESSED_FLAG          ; See if a keypress is stored
         bne.s    idle_loop3               ; Continue waiting if not
         rts

;idle_loop:
         clr.w    doorsos::kb_vars+$1c          ; Clear keypress counter
         tst.w    doorsos::kb_vars+$1c          ; See if a keypress is stored
         bne.s      idle_loop                ; Continue waiting if not
;idle_loop2:
         tst.w    doorsos::kb_vars+$1c          ; See if a keypress is stored
         beq.s      idle_loop2               ; Continue waiting if not
         clr.w    doorsos::kb_vars+$1c          ; Clear keypress counter
         move.w   doorsos::kb_vars+$1e,d0       ; Read keypress
;idle_loop3:
         clr.w    doorsos::kb_vars+$1c          ; Clear keypress counter
         tst.w    doorsos::kb_vars+$1c          ; See if a keypress is stored
         bne.s      idle_loop3               ; Continue waiting if not
         rts
;*******************************************Load Game
;*
;*	Doesn't do JACK, just helps us know whats going on
;*
;*********
open_saved_game:
	Fade	#16

	move.w	bomberd2::current_style,d0
	jsr	bomberd1::get_style
	bsr	load_style

	bra begin_main_loop

;*******************************************Begin Random Game
;*
;*	Start a randomly generated single level game
;*
;*********
begin_random_game:
	bsr		reset_game_variables
	move.w	#0,bomberd2::level
	bra restart_game

;*******************************************Round Display Delay
;*
;*	Delay the calculator after presenting the round window
;*
;*********
round_disp_delay:
	move.l	#5,d2
round_disp_delay_loop2:
	move.l	#90000,d1
round_disp_delay_loop:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	dbra.l	d1,round_disp_delay_loop
	dbra.l	d2,round_disp_delay_loop2
	rts

;*******************************************Display Life
;*
;*	Display player's life
;*
;*********
draw_life:
	move.w	#133,d0
	move.w	#47,d1
	moveq.w	#10,d2
	moveq.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	cmp.w	#0,bomberd2::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#133,#47
	cmp.w	#1,bomberd2::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#139,#47
	cmp.w	#2,bomberd2::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#133,#52
	cmp.w	#3,bomberd2::pllife
	beq		exit_draw_life
	PutGray4SpriteMask sprite_heart0,sprite_heart1,#%11111000,#139,#52
exit_draw_life:
	rts

;*******************************************Display Level
;*
;*	Display player's level
;*
;*********
draw_level:
	move.w	#133,d0
	move.w	#20,d1
	moveq.w	#10,d2
	moveq.w	#10,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	cmp.w	#0,bomberd2::level
	beq		draw_level_random
	cmp.w	#10,bomberd2::level
	bcc		draw_level_double
	clr.l	d0
	move.w	bomberd2::level,d0
	;print_d0	#122,#22,#1
	print_d0_special2	#135,#22

	rts
draw_level_random:
	WriteStr	#135,#22,#1,random_level_char
	rts
draw_level_double:
	move.w	bomberd2::level,d0
	;print_d0	#124,#22,#1
	print_d0_special2	#133,#22
	rts

;*******************************************Display Score
;*
;*	Display player's score
;*
;*********
draw_score:
	cmp.w	#1000,bomberd2::score
	bcs		ds_score_is_less_than_maximum
		move.w	bomberd2::score,d0
		sub.w	#1000,d0
		move.w	d0,bomberd2::score
		add.w	#1,bomberd2::scoreh
	ds_score_is_less_than_maximum:

	move.w	bomberd2::score,d0
	move.w	d0,bomberd2::old_score

	move.w	#133,d0
	move.w	#95,d1
	moveq.w	#27,d2
	moveq.w	#5,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill

	SetFont	#0
	
	cmp.w	#10,bomberd2::score
	bcc		dc_score_greater_ten
		WriteStr	#146,#95,#1,zero
	dc_score_greater_ten:
	cmp.w	#100,bomberd2::score
	bcc		dc_score_greater_hundred
		WriteStr	#142,#95,#1,zero
	dc_score_greater_hundred:

	cmp.w	#10,bomberd2::scoreh
	bcc		dc_scoreh_greater_ten
		WriteStr	#134,#95,#1,zero
	dc_scoreh_greater_ten:
	cmp.w	#100,bomberd2::scoreh
	bcc		dc_scoreh_greater_hundred
		WriteStr	#130,#95,#1,zero
	dc_scoreh_greater_hundred:

	cmp.w	#100,bomberd2::score
	bcc		dc_score_isgreater_100
	cmp.w	#0,bomberd2::score
	bne		dc_score_is_not_zero
		move.w	bomberd2::score,d0
		print_d0	#146,#95,#1
	bra		dc_score_is_end
	dc_score_is_not_zero:
		move.w	bomberd2::score,d0
		print_d0	#144,#95,#1
	bra		dc_score_is_end
	dc_score_isgreater_100:
		move.w	bomberd2::score,d0
		print_d0	#142,#95,#1
	dc_score_is_end:

	cmp.w	#0,bomberd2::scoreh
	bne		dc_scoreh_is_not_zero
	move.w	bomberd2::scoreh,d0
	print_d0	#134,#95,#1
	bra		dc_scoreh_is_zero_end
	dc_scoreh_is_not_zero:
	move.w	bomberd2::scoreh,d0
	print_d0	#134,#95,#1
	dc_scoreh_is_zero_end:

	SetFont	#1
	rts

;*******************************Fade Screen
;*
;*This fades in or out the screen
;*d0=new fade position
;******
fade_to:
	cmp.w	current_fade_pos,d0
	bhi		fade_up
	cmp.w	current_fade_pos,d0
	bcs		fade_down
	rts

fade_down:
	move.w	current_fade_pos,d1
	sub.w d0,d1
	move.w	d0,current_fade_pos
fadeloop:
	move.w #$1003,d3
	bsr wait
	move.w #9,d0
	trap #9
	jsr (a0)
	dbf d1,fadeloop(PC)
	rts

fade_up:
	move.w	d0,d1
	sub.w current_fade_pos,d1
	move.w	d0,current_fade_pos
fadeloop2:
	move.w #$1003,d3
	bsr wait
	move.w #10,d0
	trap #9
	jsr (a0)
	dbf d1,fadeloop2(PC)
	rts

wait:		;d3=0 => megafast
loopwait:	;d3=$FFFF => megaslow
 nop
 nop
 nop
 dbf d3,loopwait(PC)
 rts

;*******************************************Main Loop
;*
;*	The main loop of the program.  Here is how it works:  This loop repeats
;*	itself a very large amount of times.  Every single loop, not every
;*	set of functions get called.  Only if it is time for that to be called.
;*	That is what the t_to_* and def_t_to_* variables represent, the amount
;*	of time until that group of functions is called.  Here are the different
;*	function groups and there respective purposes.
;*
;*	Time counter		Notes
;*	------------		-----
;*	t_to_key		Gets the user's key input and processes it
;*	t_to_handle(bad name)	Moves enemies, handles bombs, extras, explosions...
;*	t_to_collision		Checks various objects if they have collided
;*	t_to_APD		The game speed timer.  This equalizes the game
;*				operations speed.  Very handy.  Heres how it works
;*				Every fraction of a second, on the dot, the 
;*				calculator processor subtracts one from
;*				APD_TIMER.  Each time t_to_APD is equal to zero
;*				in bomber code, the bomber code waits until the
;*				processor decreases APD_TIMER.  In this fashion
;*				we create a VERY exact and reliable game speed
;*				synchronizer tool!
;*
;*********
main_loop:

    	move.w	#0,bomberd2::saved_game

	cmp.w	#0,bomberd2::num_flashes_left
	beq		end_flash_check
	sub.w	#1,bomberd2::flash_countdown
	cmp.w	#0,bomberd2::flash_countdown
	bne		end_flash_check
	sub.w	#1,bomberd2::num_flashes_left
	cmp.w	#14,bomberd2::num_flashes_left
	bhi		do_large_flash
		move.w	#40,bomberd2::flash_countdown
		cmp.w	#1,bomberd2::bomber_flashed
		beq		small_flash_zero
			move.w	#1,bomberd2::bomber_flashed
			bra	end_flash_check
		small_flash_zero:
			move.w	#0,bomberd2::bomber_flashed
			bra	end_flash_check
	do_large_flash:
		cmp.w	#1,bomberd2::bomber_flashed
		beq		large_flash_zero
			move.w	#40,bomberd2::flash_countdown
			move.w	#1,bomberd2::bomber_flashed
			bra	end_flash_check
		large_flash_zero:
			move.w	#120,bomberd2::flash_countdown
			move.w	#0,bomberd2::bomber_flashed
			bra	end_flash_check
	end_flash_check:

		;Handle changes in score since last round
	move.w	bomberd2::old_score,d0
	cmp.w	bomberd2::score,d0
	beq		no_draw_score
	bsr		draw_score
	no_draw_score:

		;Check game ending countdowns
	cmp.w	#0,bomberd2::count_down_flag
	beq		no_count_down
	subq.w	#1,bomberd2::count_down_n
	cmp.w	#0,bomberd2::count_down_n
	beq		level_break
	no_count_down:

		;Check if there is a poison on the bomber
	cmp.w	#0,bomberd2::poisontype
	beq		end_check_poison
	sub.l	#1,bomberd2::poison_count_down_n
	cmp.l	#0,bomberd2::poison_count_down_n
	bne		end_check_poison
	move.w	#0,bomberd2::poisontype
	end_check_poison:

		;Check If all enemies are killed
	move.w	bomberd2::enemy1count,d6
	add.w	bomberd2::enemy2count,d6
	add.w	bomberd2::enemy3count,d6
	add.w	bomberd2::enemy4count,d6
	add.w	bomberd2::enemy5count,d6
	cmp.w	#0,d6
	beq		enemies_cleared
	end_enemies_cleared:

		;Key input code
	subq.w	#1,t_to_key
	cmp.w	#0,t_to_key
	bne		no_do_key

		move.w	bomberd2::def_t_to_key,d0
		move.w	d0,t_to_key

		GetKeyStat #6
		move.b	d0,key2
		GetKeyStat #1
		move.b	d0,key3
		GetKeyStat #0
		move.b	d0,key

		btst.b	#0,key2
		beq	try_end_main_loop
		btst.b	#6,key
		beq	try_timed_bombs
	fail_try_timed_bombs:
		btst.b	#6,key3
		beq	try_power_down
	fail_try_end_main_loop:
	end_power_down:
		cmp.w	#0,bomberd2::count_down_flag
		bne		end_keypush
		cmp.w	#3,bomberd2::poisontype
		beq		bombdrop
		btst.b	#4,key
		beq	bombdrop
	fail_bombdrop:
		btst.b	#0,key
		beq	keypush
		btst.b	#1,key
		beq	keypush
		btst.b	#2,key
		beq	keypush
		btst.b	#3,key
		beq	keypush

		addq.w	#1,bomberd2::time_to_stand
		cmp.w	#3,bomberd2::time_to_stand
		beq	redraw
	end_bombdrop:

	end_keypush:

no_do_key:

		;Handle enemies
	subq.w	#1,t_to_handle_enemies
	cmp.w	#0,t_to_handle_enemies
	bne		no_do_handle_enemies

		move.w	def_t_to_handle_enemies,d0
		move.w	d0,t_to_handle_enemies

			move.w	bomberd2::enemy1count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy1_loop_1
			subq.w	#1,d7
		ml_enemy1_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy1
			jsr	bomberd3::move_enemy1
			dbra.w	d7,ml_enemy1_loop_1
		ml_end_enemy1_loop_1:

			move.w	bomberd2::enemy2count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy2_loop_1
			subq.w	#1,d7
		ml_enemy2_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy2
			jsr	bomberd3::move_enemy2
			dbra.w	d7,ml_enemy2_loop_1
		ml_end_enemy2_loop_1:

			move.w	bomberd2::enemy3count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy3_loop_1
			subq.w	#1,d7
		ml_enemy3_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy3
			jsr	bomberd3::move_enemy3
			dbra.w	d7,ml_enemy3_loop_1
		ml_end_enemy3_loop_1:

			move.w	bomberd2::enemy4count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy4_loop_1
			subq.w	#1,d7
		ml_enemy4_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy4
			jsr	bomberd3::move_enemy4
			dbra.w	d7,ml_enemy4_loop_1
		ml_end_enemy4_loop_1:

			move.w	bomberd2::enemy5count,d7
			cmp.w	#0,d7
			ble		ml_end_enemy5_loop_1
			subq.w	#1,d7
		ml_enemy5_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy5
			jsr	bomberd3::move_enemy5
			dbra.w	d7,ml_enemy5_loop_1
		ml_end_enemy5_loop_1:

		bra		ml_did_handle_enemies

no_do_handle_enemies:

ml_did_handle_enemies:

		;Handle bombs, explosions, and bonuses
	subq.w	#1,t_to_handle
	cmp.w	#0,t_to_handle
	bne		no_do_handle

		move.w	def_t_to_handle,d0
		move.w	d0,t_to_handle

			move.w	bomberd2::bexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_bexp_loop_1
			subq.w	#1,d7
		ml_bexp_loop_1:
			move.w	d7,d6
			move.l	d7,-(a7)
			jsr	bomberd4::handle_bexp
			move.l	(a7)+,d7
			dbra.w	d7,ml_bexp_loop_1
		ml_end_bexp_loop_1:

			move.w	bomberd2::bombcount,d7
			cmp.w	#0,d7
			beq		ml_end_bomb_loop_1
			subq.w	#1,d7
		ml_bomb_loop_1:
			move.w	d7,d6
			move.l	d7,-(a7)
			jsr	bomberd4::handle_bomb
			move.l	(a7)+,d7
			dbra.w	d7,ml_bomb_loop_1
		ml_end_bomb_loop_1:

			move.w	bomberd2::minecount,d7
			cmp.w	#0,d7
			beq		ml_end_mine_loop_1
			subq.w	#1,d7
		ml_mine_loop_1:
			move.w	d7,d6
			move.l	d7,-(a7)
			jsr	bomberd4::handle_mine
			move.l	(a7)+,d7
			dbra.w	d7,ml_mine_loop_1
		ml_end_mine_loop_1:

		move.w	#0,bomberd2::bombs_are_triggered

			move.w	bomberd2::hexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_hexp_loop_1
			subq.w	#1,d7
		ml_hexp_loop_1:
			move.w	d7,d6
			move.l	d7,-(a7)
			jsr	bomberd4::handle_hexp
			move.l	(a7)+,d7
			dbra.w	d7,ml_hexp_loop_1
		ml_end_hexp_loop_1:

			move.w	bomberd2::vexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_vexp_loop_1
			subq.w	#1,d7
		ml_vexp_loop_1:
			move.w	d7,d6
			move.l	d7,-(a7)
			jsr	bomberd4::handle_vexp
			move.l	(a7)+,d7
			dbra.w	d7,ml_vexp_loop_1
		ml_end_vexp_loop_1:

			move.w	bomberd2::xexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_xexp_loop_1
			subq.w	#1,d7
		ml_xexp_loop_1:
			move.w	d7,d6
			move.l	d7,-(a7)
			jsr	bomberd4::handle_xexp
			move.l	(a7)+,d7
			dbra.w	d7,ml_xexp_loop_1
		ml_end_xexp_loop_1:

		bra		ml_did_handle

no_do_handle:

ml_did_handle:

		;Handle collisions
	subq.w	#1,t_to_collision
	cmp.w	#0,t_to_collision
	bne		no_do_collision

		move.w	def_t_to_collision,d0
		move.w	d0,t_to_collision

		cmp.w	#0,bomberd2::count_down_n
		bne		no_do_col_cus_game_ended
			bra		col_me_vs_enemy1
			end_col_me_vs_enemy1:
			bra		col_me_vs_enemy2
			end_col_me_vs_enemy2:
			bra		col_me_vs_enemy3
			end_col_me_vs_enemy3:
			bra		col_me_vs_enemy4
			end_col_me_vs_enemy4:
			bra		col_me_vs_enemy5
			end_col_me_vs_enemy5:
			bra		col_me_vs_hexp
			end_col_me_vs_hexp:
			bra		col_me_vs_vexp
			end_col_me_vs_vexp:
			bra		col_me_vs_xexp
			end_col_me_vs_xexp:
			bsr		col_me_vs_mine
			bsr		col_me_vs_bonus
		no_do_col_cus_game_ended:

		bsr		col_en1_vs_hexp
		bsr		col_en1_vs_vexp
		bsr		col_en1_vs_mine
		bsr		col_en2_vs_hexp
		bsr		col_en2_vs_vexp
		bsr		col_en2_vs_mine
		bsr		col_en3_vs_hexp
		bsr		col_en3_vs_vexp
		bsr		col_en3_vs_mine
		bsr		col_en3_vs_bomb
		bsr		col_en4_vs_hexp
		bsr		col_en4_vs_mine
		bsr		col_en4_vs_vexp
		bsr		col_en5_vs_hexp
		bsr		col_en5_vs_mine
		bsr		col_en5_vs_vexp
		end_i_have_died:
no_do_collision:

		;Handle drawing stuff to the screen
	subq.w	#1,t_to_draw
	cmp.w	#0,t_to_draw
	bne		no_do_draw
		move.w	def_t_to_draw,d0
		move.w	d0,t_to_draw

			move.w	bomberd2::bonuscount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_bonus_loop_1
			subq.w	#1,d7
		ml_draw_bonus_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_bonus
			dbra.w	d7,ml_draw_bonus_loop_1
		ml_end_draw_bonus_loop_1:

			move.w	bomberd2::bexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_bexp_loop_1
			subq.w	#1,d7
		ml_draw_bexp_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_bexp
			dbra.w	d7,ml_draw_bexp_loop_1
		ml_end_draw_bexp_loop_1:

			move.w	bomberd2::bombcount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_bomb_loop_1
			subq.w	#1,d7
		ml_draw_bomb_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_bomb
			dbra.w	d7,ml_draw_bomb_loop_1
		ml_end_draw_bomb_loop_1:

			move.w	bomberd2::minecount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_mine_loop_1
			subq.w	#1,d7
		ml_draw_mine_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_mine
			dbra.w	d7,ml_draw_mine_loop_1
		ml_end_draw_mine_loop_1:

			move.w	bomberd2::hexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_hexp_loop_1
			subq.w	#1,d7
		ml_draw_hexp_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_hexp
			dbra.w	d7,ml_draw_hexp_loop_1
		ml_end_draw_hexp_loop_1:

			move.w	bomberd2::vexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_vexp_loop_1
			subq.w	#1,d7
		ml_draw_vexp_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_vexp
			dbra.w	d7,ml_draw_vexp_loop_1
		ml_end_draw_vexp_loop_1:

			move.w	bomberd2::xexpcount,d7
			cmp.w	#0,d7
			beq		ml_end_draw_xexp_loop_1
			subq.w	#1,d7
		ml_draw_xexp_loop_1:
			move.w	d7,d6
			jsr	bomberd4::draw_xexp
			dbra.w	d7,ml_draw_xexp_loop_1
		ml_end_draw_xexp_loop_1:

			move.w	bomberd2::enemy1count,d7
			cmp.w	#0,d7
			beq		ml_end_draw_enemy1_loop_1
			subq.w	#1,d7
		ml_draw_enemy1_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy1
			jsr	bomberd3::draw_enemy1
			dbra.w	d7,ml_draw_enemy1_loop_1
		ml_end_draw_enemy1_loop_1:

			move.w	bomberd2::enemy2count,d7
			cmp.w	#0,d7
			beq		ml_end_draw_enemy2_loop_1
			subq.w	#1,d7
		ml_draw_enemy2_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy2
			jsr	bomberd3::draw_enemy2
			dbra.w	d7,ml_draw_enemy2_loop_1
		ml_end_draw_enemy2_loop_1:

			move.w	bomberd2::enemy3count,d7
			cmp.w	#0,d7
			ble		ml_end_draw_enemy3_loop_1
			subq.w	#1,d7
		ml_draw_enemy3_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy3
			jsr	bomberd3::draw_enemy3
			dbra.w	d7,ml_draw_enemy3_loop_1
		ml_end_draw_enemy3_loop_1:

			move.w	bomberd2::enemy4count,d7
			cmp.w	#0,d7
			beq		ml_end_draw_enemy4_loop_1
			subq.w	#1,d7
		ml_draw_enemy4_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy4
			jsr	bomberd3::draw_enemy4
			dbra.w	d7,ml_draw_enemy4_loop_1
		ml_end_draw_enemy4_loop_1:

			move.w	bomberd2::enemy5count,d7
			cmp.w	#0,d7
			beq		ml_end_draw_enemy5_loop_1
			subq.w	#1,d7
		ml_draw_enemy5_loop_1:
			move.w	d7,d6
			jsr	bomberd3::learn_enemy5
			jsr	bomberd3::draw_enemy5
			dbra.w	d7,ml_draw_enemy5_loop_1
		ml_end_draw_enemy5_loop_1:

		bsr		draw_sprite
		bsr		draw_screen

		cmp.w	#0,disp_level_count
		beq		no_disp_level
		cmp.w	#0,bomberd2::level
		beq		no_disp_level
			sub.w	#1,disp_level_count
			clr.l	d1
			move.w	disp_level_count,d1
			divu	#2,d1
			swap	d1
			cmp.w	#0,d1
			bne		disp_level_no_y_shift
				sub.w	#1,disp_level_y
			disp_level_no_y_shift:
			PutGray4Sprite2	sprite_level0,sprite_level1,sprite_levelm,#35,disp_level_y
			move.w	bomberd2::level,d0
			print_d0_special	#87,disp_level_y
		no_disp_level:

no_do_draw:

		;Handle the game speed timer, maintaning constant game speed


	subq.w	#1,t_to_APD
	cmp.w	#0,t_to_APD
	bne		no_do_APD
		move.w	bomberd2::def_t_to_APD,d0
		move.w	d0,t_to_APD

		;clr.w	APD_FLAG
		APD_loop:
		push.w    #2
		jsr    doorsos::OSTimerCurVal
		addq.l    #2,a7
		;move.w	#4,-(a7)
		;jsr	doorsos::OSTimerExpired
		;addq.l	#2,a7
		;lop:
		;bra	lop
		cmp.w	#21,d0
		beq	APD_loop
		;cmp.w	#0,APD_FLAG
		;beq	APD_loop

		    pushm.l    d0-d7/a0-a6
			clr.l        d3
			move.w		#21,d3
			move.w        #2,-(a7)
			jsr    doorsos::OSFreeTimer
			move.l        d3,-(a7)
			move.w        #2,-(a7)
			jsr    doorsos::OSRegisterTimer
			addq.l        #8,a7
			popm.l        d0-d7/a0-a6

		;push.w    #2
		;jsr    doorsos::OSTimerRestart
		;addq.l    #2,a7

		;clr.w	APD_FLAG

		;move.l	#5,APD_TIMER
no_do_APD:

	bra main_loop

try_end_main_loop:			;when the esc button is clicked
	btst.b	#0,key
	beq	fail_try_end_main_loop


	try_end_main_loop_wait_for_release:
		GetKeyStat #6
		move.b	d0,key2

		btst.b	#0,key2
		beq	try_end_main_loop_wait_for_release

	bra	exit_game_ask_save

try_power_down:				;turn off calc (Clear button)
	trap #4
	bra	end_power_down

try_timed_bombs:			;if timed bombs are activated (DIMOND)
	cmp.w	#0,bomberd2::bombcount
	bne	timed_bombs_hit
	bra	fail_try_timed_bombs

bombdrop:				;player drops a bomb (2nd)
	cmp.w	#2,bomberd2::poisontype
	beq		fail_bombdrop
		
	SetPosInfo bomberd2::plx,bomberd2::ply
	move.w	block_x,d0
	move.w	block_y,d1
	GetBoard d4
	cmp.w	#0,d4
	bne		fail_bombdrop

	move.w	bomberd2::minecount,d0
	move.w	bomberd2::minesallowed,d1
	cmp.w	d1,d0
	beq		fail_drop_mine
	move.w	block_x,x
	move.w	block_y,y
	jsr	bomberd4::add_mine
	bra	end_bombdrop
	fail_drop_mine:


	move.w	bomberd2::playerbombcount,d0
	move.w	bomberd2::bombsallowed,d1
	cmp.w	d1,d0
	beq		fail_bombdrop
	move.w	block_x,x
	move.w	block_y,y
	move.w	#0,o
	jsr	bomberd4::add_bomb
	bra end_bombdrop

keypush:					;the player wants to move
	move.w	#0,bomberd2::time_to_stand
	bsr	movement
	SetPosInfo bomberd2::plx,bomberd2::ply
	bsr	check_movement
	bsr	check_scroll
	move.w	bomberd2::plx,bomberd2::oldx
	move.w	bomberd2::ply,bomberd2::oldy
	move.w	bomberd2::spritelevel,bomberd2::oldspritelevel
	move.w	bomberd2::oldmove,bomberd2::oldoldmove

	bra	end_keypush

timed_bombs_hit:				;a second check for bomb triggering
	cmp.w	#0,bomberd2::trigger_bombs
	beq	end_keypush
	move.w	#1,bomberd2::bombs_are_triggered
	bra	end_keypush

redraw:									;redraw the bomber and surrounding
	move.w	#0,bomberd2::time_to_stand	;blocks and whatnot(not the whole
	move.w	#0,bomberd2::spritelevel		;board!!!
	;bsr	clear_sprite
	;bsr	check_redraw
	;bsr	draw_sprite
	move.w	bomberd2::plx,bomberd2::oldx
	move.w	bomberd2::ply,bomberd2::oldy
	move.w	bomberd2::oldmove,bomberd2::oldoldmove
	move.w	bomberd2::spritelevel,bomberd2::oldspritelevel
	bra	end_keypush

;*******************************************Ask To Save Game
;*
;*	The player quit the game, ask them if they want to save it
;*
;*********
exit_game_ask_save:
	lea		ask_save_text,a0
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	lea		ask_save_text,a0
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	WriteStr	#50,#50,#1,ask_save_text
	WriteStr	#64,#60,#1,ask_save_text_options
exit_game_ask_save_loop:
	bsr		asksave_wait_key

	cmp.w	#110,d0
	beq.s		exit_game_no_save
	cmp.w	#121,d0
	beq.s		exit_game_w_game_save
	cmp.w	#264,d0
	beq		begin_main_loop
	bra.s	exit_game_ask_save_loop

exit_game_w_game_save:
	move.w	#1,bomberd2::saved_game
	bra		end_main_loop

exit_game_no_save:
	move.w	#0,bomberd2::saved_game
	jsr	bomberd2::check_high_score
	bra  	end_main_loop

asksave_wait_key:
	GetKeyStat #2
	move.b	d0,key
	GetKeyStat #4
	move.b	d0,key1
	GetKeyStat #6
	move.b	d0,key2
	btst.b	#0,key2
	beq	asksave_wait_key_escape
	btst.b	#5,key1
	beq	asksave_wait_key_y
	btst.b	#2,key
	beq	asksave_wait_key_n
	bra		asksave_wait_key

asksave_wait_key_y:
	asksave_wait_y_released:
	GetKeyStat #4
	move.b	d0,key
	btst.b	#5,key
	beq	asksave_wait_y_released
	move.w	#121,d0
	rts
asksave_wait_key_n:
	asksave_wait_n_released:
	GetKeyStat #2
	move.b	d0,key
	btst.b	#2,key
	beq	asksave_wait_n_released
	move.w	#110,d0
	rts
asksave_wait_key_escape:
	btst.b	#0,key
	beq	asksave_wait_key
	asksave_wait_esc_released:
	GetKeyStat #6
	move.b	d0,key
	btst.b	#0,key
	beq	asksave_wait_esc_released
	move.w	#264,d0
	rts

;*******************************************I have been killed
;*
;*	I have collided, this starts the time-to-game-ending timer
;*	the game still runs for 500 mainloop revolutions
;*
;********
i_have_died:
	cmp.w	#1,bomberd2::death_protection
	beq		i_have_died_w_death_protection
	move.w	#1,bomberd2::count_down_flag
	move.w	#500,bomberd2::count_down_n
	move.w	#1,bomberd2::count_down_reason	;one means I have died
	move.w	#1,bomberd2::bmexp_current_sprite
	bra		end_i_have_died

i_have_died_w_death_protection:
	move.w	#0,bomberd2::death_protection
	move.w	#70,bomberd2::num_flashes_left
	move.w	#0,bomberd2::bomber_flashed
	move.w	#80,bomberd2::flash_countdown
	bra		end_i_have_died

;*******************************************Enemies	Cleared
;*
;*	I have killed the enemies, this starts the time-to-game-ending timer
;*	the game still runs for 100 mainloop revolutions
;*
;********
enemies_cleared:
	tst.w	bomberd2::count_down_reason
	bne		end_enemies_cleared

	move.w	#1,bomberd2::count_down_flag
	move.w	#100,bomberd2::count_down_n
	move.w	#2,bomberd2::count_down_reason	;2 means enemies killed
	bra		end_enemies_cleared

;*******************************************End of counter
;*
;*	The game time-to-ending counter has gone from 100 to 0
;*	The game has now really ended
;*
;********
level_break:
	cmp.w	#1,bomberd2::count_down_reason
	beq		level_break_death

	cmp.w	#2,bomberd2::count_down_reason
	beq		level_break_enemy_cleared

	move.w	#0,bomberd2::count_down_reason
	move.w	#0,bomberd2::count_down_flag
	bra		main_loop		;not a valid reason

level_break_death:
	cmp.w	#0,bomberd2::pllife
	beq		call_check_high_score
	subq.w	#1,bomberd2::pllife
	bra		restart_game

level_break_enemy_cleared:
	cmp.w	#0,bomberd2::enemy1count
	bne		end_enemies_cleared
	cmp.w	#0,bomberd2::level
	beq		call_check_high_score

	cmp.w	#15,bomberd2::level
	beq		call_check_high_score

	addq.w	#1,bomberd2::level
	cmp.w	#4,bomberd2::level
	beq		add_difficulty
	cmp.w	#7,bomberd2::level
	beq		add_difficulty
	cmp.w	#10,bomberd2::level
	beq		add_difficulty
	cmp.w	#13,bomberd2::level
	beq		add_difficulty
	bra		restart_game

add_difficulty:					;go to next level, 
						;increase difficulty
	addq.w	#1,bomberd2::game_difficulty
	Fade	#16
	bra		restart_game

call_check_high_score:					;is over man!!!
	jsr		bomberd2::check_high_score
	bra		startup

;*******************************************Draw Sprite Double Buffer Mask
;*
;*	This code draws a sprite that is two bytes wide to the double buffer
;*
;*		Input:	a0=sprite
;*				d2=x position in board pixels
;*				d3=y position in board pixels
;*				d6=the sprites height
;********
DrawSpriteDoubleBuffer: 
  move.l	a0,a1
  add.l	d6,a1
  add.l	d6,a1
  move.w bomberd2::map_x,d1
  add.w  #128,d1
  cmp.w	d1,d2
  bhi	exit_draw_sprite
  move.w d2,d1
  add.w  #16,d1
  cmp.w	bomberd2::map_x,d1
  bcs	exit_draw_sprite
  move.w bomberd2::map_y,d1
  add.w  #100,d1
  cmp.w	d1,d3
  bhi	exit_draw_sprite
  move.w d3,d1
  add.w  #16,d1
  cmp.w	bomberd2::map_y,d1
  bcs	exit_draw_sprite
  add.w	#16,d2
  add.w	#16,d3
  move.l DispContext0,a3
  move.l DispContext1,a4
  ;adda   #386,a3
  ;adda   #386,a4
  ;adda   #16,a3
  ;adda   #16,a4
  move.l d3,d0
  clr.l	 d1
  move.w bomberd2::map_y,d1
  sub.l  d1,d0
  mulu   #24,d0
  add.l  d0,a3
  add.l  d0,a4
  move.l d2,d0
  clr.l	 d1
  move.w bomberd2::map_x,d1
  sub.l  d1,d0
  move.l d0,d1
  lsr    #4,d0
  lsl    #1,d0
  add.l  d0,a3
  add.l  d0,a4
  lsl    #3,d0
  sub.w  d0,d1     ;d1 holds bit shift
  move.l d6,d0
  subq.w #1,d0
DrawSpriteLoop:
  clr.l  d4
  clr.l  d5
  clr.l  d3
  move.w (a0)+,d4
  move.w (a1)+,d5
  move.l #$FFFF0000,d3
  rol.l  #8,d4
  rol.l  #8,d5
  rol.l  #8,d4
  rol.l  #8,d5
  ror.l  d1,d3
  ror.l  d1,d4
  ror.l  d1,d5
  not.l  d3
  and.l  d3,(a3)
  and.l  d3,(a4)
  or.l   d4,(a3)
  or.l   d5,(a4)
  adda   #24,a3
  adda   #24,a4
  dbra   d0,DrawSpriteLoop
exit_draw_sprite:
  rts

;*******************************************Draw Sprite Double Buffer Mask
;*
;*	This code draws a sprite that is two bytes wide to the double buffer
;*
;*		Input:	a0=sprite
;*				d2=x position in board pixels
;*				d3=y position in board pixels
;*				d6=the sprites height
;********
bomber89@0000:
DrawSpriteDoubleBufferMask:
  move.l	a0,a1
  add.l	d6,a1
  add.l	d6,a1
  move.l	a1,a2
  add.l	d6,a2
  add.l	d6,a2
  move.w bomberd2::map_x,d1
  add.w  #128,d1
  cmp.w	d1,d2
  bhi	exit_draw_sprite_mask
  move.w d2,d1
  add.w  #16,d1
  cmp.w	bomberd2::map_x,d1
  bcs	exit_draw_sprite_mask
  move.w bomberd2::map_y,d1
  add.w  #100,d1
  cmp.w	d1,d3
  bhi	exit_draw_sprite_mask
  move.w d3,d1
  add.w  #16,d1
  cmp.w	bomberd2::map_y,d1
  bcs	exit_draw_sprite_mask
  add.w	#16,d2
  add.w	#16,d3
  move.l DispContext0,a3
  move.l DispContext1,a4
  ;adda   #386,a3
  ;adda   #386,a4
  ;adda   #16,a3
  ;adda   #16,a4
  move.l d3,d0
  clr.l	 d1
  move.w bomberd2::map_y,d1
  sub.l  d1,d0
  mulu   #24,d0
  add.l  d0,a3
  add.l  d0,a4
  move.l d2,d0
  clr.l	 d1
  move.w bomberd2::map_x,d1
  sub.l  d1,d0
  move.l d0,d1
  lsr    #4,d0
  lsl    #1,d0
  add.l  d0,a3
  add.l  d0,a4
  lsl    #3,d0
  sub.w  d0,d1     ;d1 holds bit shift
  move.l d6,d0
  subq.w #1,d0
DrawSpriteLoopMask:
  clr.l  d4
  clr.l  d5
  clr.l  d3
  move.w (a0)+,d4
  move.w (a1)+,d5
  move.w (a2)+,d3
  rol.l  #8,d3
  rol.l  #8,d4
  rol.l  #8,d5
  rol.l  #8,d3
  rol.l  #8,d4
  rol.l  #8,d5
  ror.l  d1,d3
  ror.l  d1,d4
  ror.l  d1,d5
  not.l  d3
  and.l  d3,(a3)
  and.l  d3,(a4)
  or.l   d4,(a3)
  or.l   d5,(a4)
  adda   #24,a3
  adda   #24,a4
  dbra   d0,DrawSpriteLoopMask
exit_draw_sprite_mask:
  rts

;*******************************************Draw Sprite Double Buffer Mask
;*
;*	This code draws a sprite that is two bytes wide to the double buffer
;*
;*		Input:	a0=sprite
;*				d2=x position in board pixels
;*				d3=y position in board pixels
;*				d6=the sprites height
;********
DrawSpriteBlackMask:
  move.l	a0,a1
  add.l	d6,a1
  add.l	d6,a1
  move.l	a1,a2
  add.l	d6,a2
  add.l	d6,a2
  move.w bomberd2::map_x,d1
  add.w  #128,d1
  cmp.w	d1,d2
  bhi	exit_draw_sprite_black_mask
  move.w d2,d1
  add.w  #16,d1
  cmp.w	bomberd2::map_x,d1
  bcs	exit_draw_sprite_black_mask
  move.w bomberd2::map_y,d1
  add.w  #100,d1
  cmp.w	d1,d3
  bhi	exit_draw_sprite_black_mask
  move.w d3,d1
  add.w  #16,d1
  cmp.w	bomberd2::map_y,d1
  bcs	exit_draw_sprite_black_mask
  add.w	#16,d2
  add.w	#16,d3
  move.l DispContext0,a3
  move.l DispContext1,a4
  ;adda   #386,a3
  ;adda   #386,a4
  ;adda   #16,a3
  ;adda   #16,a4
  move.l d3,d0
  clr.l	 d1
  move.w bomberd2::map_y,d1
  sub.l  d1,d0
  mulu   #24,d0
  add.l  d0,a3
  add.l  d0,a4
  move.l d2,d0
  clr.l	 d1
  move.w bomberd2::map_x,d1
  sub.l  d1,d0
  move.l d0,d1
  lsr    #4,d0
  lsl    #1,d0
  add.l  d0,a3
  add.l  d0,a4
  lsl    #3,d0
  sub.w  d0,d1     ;d1 holds bit shift
  move.l d6,d0
  subq.w #1,d0
DrawSpriteLoopBlackMask:
  clr.l  d3
  move.w (a2)+,d3
  rol.l  #8,d3
  rol.l  #8,d3
  ror.l  d1,d3
  not.l  d3
  and.l  d3,(a3)
  and.l  d3,(a4)
  not.l	 d3
  or.l   d3,(a3)
  or.l   d3,(a4)
  adda   #24,a3
  adda   #24,a4
  dbra   d0,DrawSpriteLoopBlackMask
exit_draw_sprite_black_mask:
  rts

;*******************************Draw Screen
;*
;*This draws the temporary screen to the lcd screen
;*
;******
draw_screen:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l DispContext0,a0
	move.l DispContext1,a1
	move.l graphlib::plane0,a2
	move.l graphlib::plane1,a3
	adda   #386,a0
	adda   #386,a1
	move.l #99,d0
ScreenLoop:
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	;move.l (a0)+,(a2)+
	;move.l (a1)+,(a3)+
	adda   #4,a0
	adda   #4,a1
	adda   #4,a2
	adda   #4,a3
	adda   #4,a0
	adda   #4,a1
	adda   #10,a2
	adda   #10,a3
	dbra   d0,ScreenLoop
	bsr	copy_background_to_screen
	movem.l	(a7)+,d0-d7/a0-a6
	rts

;*******************************Background to Screen
;*
;*This draws the background to the temporary screen
;*
;******
copy_background_to_screen:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l BKGScreen0,a0
	move.l BKGScreen1,a1
	move.l Screen0,a2
	move.l Screen1,a3
	adda   #386,a0
	adda   #386,a1
	adda   #386,a2
	adda   #386,a3
	move.l #99,d0
CopyBackToScreenLoop:
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	move.l (a0)+,(a2)+
	move.l (a1)+,(a3)+
	adda   #4,a0
	adda   #4,a1
	adda   #4,a2
	adda   #4,a3
	dbra   d0,CopyBackToScreenLoop
	movem.l	(a7)+,d0-d7/a0-a6
	rts

;*******************************Clear temp screen
;*
;*This is used to clear the temporary screens
;*
;******
clear_temp_screen:
	movem.l   d0-d1/a0-a1,-(a7)
	clr.l   d0
	move.l  #791,d1
	move.l  DispContext0,a0
	move.l  DispContext1,a1
ClrTempLoop:
	move.l  d0,(a0)+
	move.l  d0,(a1)+
	dbra    d1,ClrTempLoop
	movem.l   (a7)+,d0-d1/a0-a1
	rts

;*******************************Display Number
;*
;*Display Number Special I(d0=x, d1=y, a0=string)
;*
;******
write_str_special:
	move.b	(a0)+,d2
	cmp.b	#32,d2
	beq		write_str_special
	cmp.b	#0,d2
	beq		return
	sub.b	#48,d2
	move.l	a0,-(a7)
	bsr		draw_num_char_special
	move.l	(a7)+,a0
	add.w	#9,d0
	bra		write_str_special

draw_num_char_special:
	cmp.w	#0,d2
	beq		draw_char_special_0
	cmp.w	#1,d2
	beq		draw_char_special_1
	cmp.w	#2,d2
	beq		draw_char_special_2
	cmp.w	#3,d2
	beq		draw_char_special_3
	cmp.w	#4,d2
	beq		draw_char_special_4
	cmp.w	#5,d2
	beq		draw_char_special_5
	cmp.w	#6,d2
	beq		draw_char_special_6
	cmp.w	#7,d2
	beq		draw_char_special_7
	cmp.w	#8,d2
	beq		draw_char_special_8
	cmp.w	#9,d2
	beq		draw_char_special_9
	rts

draw_char_special_0:
	PutGray4Sprite2	sprite_char00,sprite_char01,sprite_char0m,d0,d1
	rts
draw_char_special_1:
	PutGray4Sprite2	sprite_char10,sprite_char11,sprite_char1m,d0,d1
	rts
draw_char_special_2:
	PutGray4Sprite2	sprite_char20,sprite_char21,sprite_char2m,d0,d1
	rts
draw_char_special_3:
	PutGray4Sprite2	sprite_char30,sprite_char31,sprite_char3m,d0,d1
	rts
draw_char_special_4:
	PutGray4Sprite2	sprite_char40,sprite_char41,sprite_char4m,d0,d1
	rts
draw_char_special_5:
	PutGray4Sprite2	sprite_char50,sprite_char51,sprite_char5m,d0,d1
	rts
draw_char_special_6:
	PutGray4Sprite2	sprite_char60,sprite_char61,sprite_char6m,d0,d1
	rts
draw_char_special_7:
	PutGray4Sprite2	sprite_char70,sprite_char71,sprite_char7m,d0,d1
	rts
draw_char_special_8:
	PutGray4Sprite2	sprite_char80,sprite_char81,sprite_char8m,d0,d1
	rts
draw_char_special_9:
	PutGray4Sprite2	sprite_char90,sprite_char91,sprite_char9m,d0,d1
	rts

;*******************************Display Number, Font 2
;*
;*Display Number Special2 I(d0=x, d1=y, a0=string)
;*
;******
write_str_special2:
	move.b	(a0)+,d2
	cmp.b	#32,d2
	beq		write_str_special2
	cmp.b	#0,d2
	beq		return
	sub.b	#48,d2
	move.l	a0,-(a7)
	bsr		draw_num_char_special2
	move.l	(a7)+,a0
	add.w	#6,d0
	bra		write_str_special2

draw_num_char_special2:
	cmp.w	#0,d2
	beq		draw_char_special2_0
	cmp.w	#1,d2
	beq		draw_char_special2_1
	cmp.w	#2,d2
	beq		draw_char_special2_2
	cmp.w	#3,d2
	beq		draw_char_special2_3
	cmp.w	#4,d2
	beq		draw_char_special2_4
	cmp.w	#5,d2
	beq		draw_char_special2_5
	cmp.w	#6,d2
	beq		draw_char_special2_6
	cmp.w	#7,d2
	beq		draw_char_special2_7
	cmp.w	#8,d2
	beq		draw_char_special2_8
	cmp.w	#9,d2
	beq		draw_char_special2_9
	rts

draw_char_special2_0:
	PutGray4Sprite2	sprite_char200,sprite_char201,sprite_char20m,d0,d1
	rts
draw_char_special2_1:
	PutGray4Sprite2	sprite_char210,sprite_char211,sprite_char21m,d0,d1
	rts
draw_char_special2_2:
	PutGray4Sprite2	sprite_char220,sprite_char221,sprite_char22m,d0,d1
	rts
draw_char_special2_3:
	PutGray4Sprite2	sprite_char230,sprite_char231,sprite_char23m,d0,d1
	rts
draw_char_special2_4:
	PutGray4Sprite2	sprite_char240,sprite_char241,sprite_char24m,d0,d1
	rts
draw_char_special2_5:
	PutGray4Sprite2	sprite_char250,sprite_char251,sprite_char25m,d0,d1
	rts
draw_char_special2_6:
	PutGray4Sprite2	sprite_char260,sprite_char261,sprite_char26m,d0,d1
	rts
draw_char_special2_7:
	PutGray4Sprite2	sprite_char270,sprite_char271,sprite_char27m,d0,d1
	rts
draw_char_special2_8:
	PutGray4Sprite2	sprite_char280,sprite_char281,sprite_char28m,d0,d1
	rts
draw_char_special2_9:
	PutGray4Sprite2	sprite_char290,sprite_char291,sprite_char29m,d0,d1
	rts

;*******************************************Return Function, returns from a jump

return:
	rts

	include "collisions.asm"	;collisions between different objects
	include "scroll.asm"	;contains the window scrolling functions
	include "sprite_proc.asm"	;the procedures for the main player
	include "board.asm"		;board drawing, clearing, generation
	include "about.asm"		;about this game function
	include "options.asm"		;game options function
	include "sprites.asm"		;includes the sprites for almost everything

;*******************************CONVERT D0 TO A STRING
;*
;*	This is used for print_d0 macro and serves no other purpose!
;*
;******
ConvStr:
    movem.l d0-d2,-(a7)
    clr.b   (a0)
	move.w	d0,d2
	clr.l	d0
	move.w	d2,d0
conv_repeat:
    divu    #10,d0
    move.l  d0,d2
    swap    d2
    add.b   #48,d2
    move.b  d2,-(a0)
    subq    #1,d1
    and.l   #$FFFF,d0
    bne     conv_repeat
    tst.w   d1
    beq     conv_done
    subq    #1,d1
fillout:
    move.b  #32,-(a0)
    dbra    d1,fillout
conv_done:
    movem.l (a7)+,d0-d2
    rts

str             ds.b 16
strend
	             ds.b 16

;*******************************************Comment

_comment   dc.b    "BomberBoy v1.0",0
        end
