;******************* Draw Enemies explosions
;*
;*	I(d0=x, d1=y)	O(d5=1 if surrounded
;*
check_surrounded:
	move.w #1,d5	
	movem.l	d0-d4,-(a7)
	move.w	d0,d2
	move.w	d1,d3

	cmp.w	#0,d0
	beq		no_check_surrounded_left
	subq.w	#1,d0
	GetBoard d4
	cmp.w	#0,d4
	beq		end_check_surrounded_not_surrounded
no_check_surrounded_left:

	move.w	d2,d0
	move.w	d3,d1
	move.w  bomberd2::map_width,d4
	subq.w	#1,d4
	cmp.w	d4,d0
	beq		no_check_surrounded_right
	addq.w	#1,d0
	GetBoard d4
	cmp.w	#0,d4
	beq		end_check_surrounded_not_surrounded
no_check_surrounded_right:

	move.w	d2,d0
	move.w	d3,d1
	cmp.w	#0,d1
	beq		no_check_surrounded_up
	subq.w	#1,d1
	GetBoard d4
	cmp.w	#0,d4
	beq		end_check_surrounded_not_surrounded
no_check_surrounded_up:

	move.w	d2,d0
	move.w	d3,d1
	move.w  bomberd2::map_height,d4
	subq.w	#1,d4
	cmp.w	d4,d1
	beq		end_check_surrounded
	addq.w	#1,d1
	GetBoard d4
	cmp.w	#0,d4
	beq		end_check_surrounded_not_surrounded
	bra		end_check_surrounded

end_check_surrounded_not_surrounded:
	move.w	#0,d5
end_check_surrounded:
	movem.l	(a7)+,d0-d4
	rts
	
	
;******************* Draw Enemies explosions
;*
;*	I(d4=x, d5=y, a4->current enemy sprite position)
;*

draw_enemy_exp1:
	Draw2ByteSpriteToBufferMaskFromLib	enexp1,d4,d5,#22
	subq.w	#1,(a4)
	rts

draw_enemy_exp2:
	Draw2ByteSpriteToBufferMaskFromLib	enexp2,d4,d5,#22
	subq.w	#1,(a4)
	rts

draw_enemy_exp3:
	Draw2ByteSpriteToBufferMaskFromLib	enexp3,d4,d5,#18
	subq.w	#1,(a4)
	rts

draw_enemy_exp4:
	Draw2ByteSpriteToBufferMaskFromLib	enexp4,d4,d5,#22
	subq.w	#1,(a4)
	rts

draw_enemy_exp5:
	Draw2ByteSpriteToBufferMaskFromLib	enexp5,d4,d5,#18
	subq.w	#1,(a4)
	rts

draw_enemy_exp6:
	Draw2ByteSpriteToBufferMaskFromLib	enexp6,d4,d5,#15
	subq.w	#1,(a4)
	rts

draw_enemy_exp7:
	Draw2ByteSpriteToBufferMaskFromLib	enexp7,d4,d5,#12
	subq.w	#1,(a4)
	rts

;******************* Check Bombs Horizontally
;*
;*	I(d0=x, d1=y)	O(d3=1 if bomb exists
;*
check_bombs_horizontal:
	move.w	#0,d3
	movem.l	d0-d2,-(a7)
	movem.l	d4-d5,-(a7)
	move.w	d0,d2
	move.w	bomberd2::bomb_exp_len,d5
	check_bombs_horizontal_left:
	cmp.w	#0,d5
	beq		end_check_bombs_horizontal_left
		subq.w	#1,d5
		subq.w	#1,d0
		GetBoard d4
		cmp.w	#3,d4
		beq		end_check_bombs_horizontal_found_bomb
		cmp.w	#0,d4
		bne		end_check_bombs_horizontal_left
		bra		check_bombs_horizontal_left

	end_check_bombs_horizontal_left:
		move.w	d2,d0
		move.w	bomberd2::bomb_exp_len,d5
	check_bombs_horizontal_right:
	cmp.w	#0,d5
	beq		end_check_bombs_horizontal
		subq.w	#1,d5
		addq.w	#1,d0
		move.w	bomberd2::map_width,d4
		cmp.w	d0,d4
		beq		end_check_bombs_horizontal
		GetBoard d4
		cmp.w	#3,d4
		beq		end_check_bombs_horizontal_found_bomb
		cmp.w	#0,d4
		bne		end_check_bombs_horizontal
		bra		check_bombs_horizontal_right
end_check_bombs_horizontal_found_bomb:
	move.w	#1,d3
	move.w	#62,(a6)
end_check_bombs_horizontal:
	cmp.w	#62,(a6)
	bne		no_chk_horiz_bomb_check_prev_bomb
		move.w	#30,(a6)
		move.w	#1,d3
	no_chk_horiz_bomb_check_prev_bomb:
	movem.l	(a7)+,d4-d5
	movem.l	(a7)+,d0-d2
	rts

;******************* Check Bombs Vertically
;*
;*	I(d0=x, d1=y)	O(d3=1 if bomb exists
;*
check_bombs_vertical:
	move.w	#0,d3
	movem.l	d0-d2,-(a7)
	movem.l	d4-d5,-(a7)
	move.w	d1,d2
	move.w	bomberd2::bomb_exp_len,d5
	check_bombs_vertical_up:
	cmp.w	#0,d5
	beq		end_check_bombs_vertical_up
		subq.w	#1,d5
		subq.w	#1,d1
		GetBoard d4
		cmp.w	#3,d4
		beq		end_check_bombs_vertical_found_bomb
		cmp.w	#0,d4
		bne		end_check_bombs_vertical_up
		bra		check_bombs_vertical_up
	end_check_bombs_vertical_up:
		move.w	d2,d1
		move.w	bomberd2::bomb_exp_len,d5
	check_bombs_vertical_down:
	cmp.w	#0,d5
	beq		end_check_bombs_vertical
		subq.w	#1,d5
		addq.w	#1,d1
		move.w	bomberd2::map_height,d4
		cmp.w	d1,d4
		beq		end_check_bombs_vertical
		GetBoard d4
		cmp.w	#3,d4
		beq		end_check_bombs_vertical_found_bomb
		cmp.w	#0,d4
		bne		end_check_bombs_vertical
		bra		check_bombs_vertical_down
end_check_bombs_vertical_found_bomb:
	move.w	#1,d3
	move.w	#60,(a6)
end_check_bombs_vertical:
	cmp.w	#66,(a6)
	bne		no_chk_vert_bomb_check_prev_bomb
		move.w	#30,(a6)
		move.w	#1,d3
	no_chk_vert_bomb_check_prev_bomb:
	movem.l	(a7)+,d4-d5
	movem.l	(a7)+,d0-d2
	rts


enexp1:
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%11100000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%11100000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%11100000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000
enexp2:
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%11100000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000
enexp3:
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%11100000
	dc.b	%00001111,%00010000
	dc.b	%00001100,%01110000
	dc.b	%00001100,%01100000
	dc.b	%00001100,%01010000
	dc.b	%00001111,%11010000
	dc.b	%00001100,%11100000
	dc.b	%00000111,%01000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%11100000
	dc.b	%00001111,%11110000
	dc.b	%00001111,%11110000
	dc.b	%00001111,%11100000
	dc.b	%00001111,%11110000
	dc.b	%00001111,%11110000
	dc.b	%00001111,%11100000
	dc.b	%00000111,%01000000
enexp4:
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%11100000
	dc.b	%00111011,%01011100
	dc.b	%01110100,%00000110
	dc.b	%11111111,%00000010
	dc.b	%11111100,%00110110
	dc.b	%11110000,%00011110
	dc.b	%11110000,%00011100
	dc.b	%01110000,%00011110
	dc.b	%11110000,%00011111
	dc.b	%11111000,%00111011
	dc.b	%11111111,%11110011
	dc.b	%11111111,%11110011
	dc.b	%11111110,%11111110
	dc.b	%01111000,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%10111000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%11100000
	dc.b	%00111011,%11111100
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111110
	dc.b	%11111111,%11111110
	dc.b	%11111111,%11111110
	dc.b	%11111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%10111000
enexp5:
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00111110,%11100000
	dc.b	%01111000,%00010000
	dc.b	%01111110,%11011000
	dc.b	%01111000,%01111000
	dc.b	%11110000,%00111000
	dc.b	%11110000,%00110000
	dc.b	%01110000,%01100110
	dc.b	%01111001,%11101111
	dc.b	%00111111,%11001001
	dc.b	%01100111,%00011011
	dc.b	%11111110,%00110011
	dc.b	%11111101,%10111110
	dc.b	%01110001,%11011100
	dc.b	%00111111,%10000000
	dc.b	%00011111,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00111111,%11100000
	dc.b	%01111111,%11110000
	dc.b	%01111111,%11111000
	dc.b	%01111111,%11111000
	dc.b	%11111111,%11111000
	dc.b	%11111111,%11111000
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111110
	dc.b	%01111111,%11011100
	dc.b	%00111111,%10000000
	dc.b	%00011111,%00000000
enexp6:
	dc.b	%00000000,%00000000
	dc.b	%00000001,%11000000
	dc.b	%00011111,%11100000
	dc.b	%00111111,%00110000
	dc.b	%00111000,%11110000
	dc.b	%00110000,%00110000
	dc.b	%00111000,%01100000
	dc.b	%00011000,%11000000
	dc.b	%00001111,%10000000
	dc.b	%00000000,%00001100
	dc.b	%00000000,%00011010
	dc.b	%00011110,%00010110
	dc.b	%00111111,%00011100
	dc.b	%00110011,%00011000
	dc.b	%00011110,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%11000000
	dc.b	%00011111,%11100000
	dc.b	%00111111,%11110000
	dc.b	%00111111,%11110000
	dc.b	%00111111,%11110000
	dc.b	%00111111,%11100000
	dc.b	%00011111,%11000000
	dc.b	%00001111,%10000000
	dc.b	%00000000,%00001100
	dc.b	%00000000,%00011110
	dc.b	%00011110,%00011110
	dc.b	%00111111,%00011100
	dc.b	%00111111,%00011000
	dc.b	%00011110,%00000000
enexp7:
	dc.b	%00000111,%10000000
	dc.b	%00001111,%11000000
	dc.b	%00001100,%11000000
	dc.b	%00001001,%11000000
	dc.b	%00000111,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00001100
	dc.b	%00000000,%00001100
	dc.b	%00011100,%00001000
	dc.b	%00001100,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%10000000
	dc.b	%00001111,%11000000
	dc.b	%00001111,%11000000
	dc.b	%00001111,%11000000
	dc.b	%00000111,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00001100
	dc.b	%00000000,%00001100
	dc.b	%00011100,%00001000
	dc.b	%00001100,%00000000

