;*******************************************Draw Enemy
;*
;*	Draws the enemy1 sprite
;*
;*	Input:	a2=points to x-coordinate in array
;*		a3=points to y-coordinate in array
;*		a4=points to current sprite information
;*
;********
bomberd3@0003:
draw_enemy1:
	move.w	(a2),d4
	move.w	(a3),d5
	move.w	(a4),d0
	cmp.w	#50,d0
	bcc		draw_enemy1_explosion

	sub.w	#8,d4
	sub.w	#16,d5
	cmp.w	#0,d0
	beq		de1_s1
	cmp.w	#1,d0
	beq		de1_s2
	cmp.w	#2,d0
	beq		de1_s3
	cmp.w	#3,d0
	beq		de1_s4
	rts

de1_s1:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy11,d4,d5,#24
	rts

de1_s2:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy12,d4,d5,#24
	rts

de1_s3:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy13,d4,d5,#24
	rts

de1_s4:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy14,d4,d5,#24
	rts

draw_enemy1_explosion:
	cmp.w	#50,d0
	beq		delete_enemy1
	subq.w	#8,d4
	sub.w	#14,d5
	cmp.w	#64,d0
	beq		draw_enemy_exp1
	cmp.w	#62,d0
	beq		draw_enemy_exp2
	cmp.w	#60,d0
	beq		draw_enemy_exp3
	cmp.w	#58,d0
	beq		draw_enemy_exp4
	cmp.w	#56,d0
	beq		draw_enemy_exp5
	cmp.w	#54,d0
	beq		draw_enemy_exp6
	cmp.w	#52,d0
	beq		draw_enemy_exp7
	cmp.w	#63,d0
	beq		draw_enemy_exp1
	cmp.w	#61,d0
	beq		draw_enemy_exp2
	cmp.w	#59,d0
	beq		draw_enemy_exp3
	cmp.w	#57,d0
	beq		draw_enemy_exp4
	cmp.w	#55,d0
	beq		draw_enemy_exp5
	cmp.w	#53,d0
	beq		draw_enemy_exp6
	cmp.w	#51,d0
	beq		draw_enemy_exp7
	rts

;*******************************************Add Enemy1
;*
;*	Add a new enemy1
;*
;*	Input:	d0=x-coordinate of new enemy1 in blocks
;*		d1=y-coordinate of new enemy1 in blocks
;*
;********
bomberd3@0004:
add_enemy1:
	move.w	d0,x
	move.w	d1,y
	movem.l	d0-d3/a0,-(a7)

	lea	bomberd2::enemy1_x,a0		;Set vexp x
	move.w  bomberd2::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::enemy1_y,a0		;Set vexp y
	move.w  bomberd2::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::enemy1_d,a0		;Set vexp s
	move.w  bomberd2::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	Random	#4,d3
	addq.w	#1,d3
	move.w	d3,(a0)

	lea	bomberd2::enemy1_s,a0		;Set vexp s
	move.w  bomberd2::enemy1count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#1,(a0)

	addq.w	#1,bomberd2::enemy1count

	movem.l	(a7)+,d0-d3/a0
	rts

;*******************************************Get Enemy 1 Stats
;*
;*	Gather pointers for a certain enemy
;*
;*	Input:	d6=the number of this enemy in the enemy arrays
;*
;*	Output:	a2=pointer to x coordinate
;*		a3=pointer to y coordinate
;*		a4=pointer to sprite info
;*		a5=pointer to enemy direction
;*
;********
bomberd3@0000:
learn_enemy1:
	lea	bomberd2::enemy1_x,a0		;Get enemy d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::enemy1_y,a0		;Get enemy d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::enemy1_s,a0		;Get enemy d6's s
	lea	0(a0,d2.w),a4

	lea	bomberd2::enemy1_d,a0		;Get enemy d6's d
	lea	0(a0,d2.w),a5
	rts

;*******************************************Move Enemy
;*
;*	Move an enemy
;*
;*	Input:	a2=pointer to x coordinate
;*		a3=pointer to y coordinate
;*		a4=pointer to sprite info
;*		a5=pointer to enemy direction
;*
;********
bomberd3@0001:
move_enemy1:
	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),dir
	SetExtraPosInfo x,y

	addq.w	#1,s
	cmp.w	#4,s
	bne		me_no_reset_s
	move.w	#0,s
me_no_reset_s:

	cmp.w	#8,erelpos_x		;IF relpos_x=5
	bne		me_else_1
	cmp.w	#8,erelpos_y		;and relpos_y=5
	bne		me_else_1
	Random  #5,d3			;and (RND*5=1)
	cmp.w	#1,d3
	bne	me_else_1

		Random  #4,d3
		addq.w	#1,d3
		move.w	d3,dir

		bra		me_end_if_1

me_else_1:

		cmp.w	#1,dir			;IF dir(a)=1 then
		bne		me_else_if_11

			cmp.w	#8,erelpos_x		;IF relpos_x>5 or relpos_x<5 then
			beq		me_else_101


				subq.w	#1,x

				bra		me_end_if_1

		me_else_101:

			cmp.w	#0,eblock_x		;IF block_x=0
			beq	me_if_1011
			move.w	eblock_x,d0		;or board((block_x-1)*10+block_y)<>0
			subq.w	#1,d0
			move.w	eblock_y,d1
			bsr		enemy1_check_pass
			cmp.w	#0,d2
			beq	me_if_1011
			
				subq.w	#1,x
				bra		me_end_if_1

			me_if_1011:

				move.w	#4,dir
				bra		me_end_if_1

	me_else_if_11:

		cmp.w	#2,dir			;IF dir(a)=2 then
		bne		me_else_if_12

			cmp.w	#8,erelpos_x		;IF relpos_x>5 or relpos_x<5 then
			beq		me_else_111


				addq.w	#1,x

				bra		me_end_if_1

		me_else_111:

			move.w   bomberd2::map_width,d0
			move.w	 eblock_x,d2
			cmp.w	d0,d2		;IF block_x=12
			beq		me_if_1111
			move.w	eblock_x,d0		;or board((block_x+1)*10+block_y)<>0
			addq.w	#1,d0
			move.w	eblock_y,d1
			bsr		enemy1_check_pass
			cmp.w	#0,d2
			beq	me_if_1111
			
				addq.w	#1,x
				bra		me_end_if_1

			me_if_1111:

				move.w	#3,dir
				bra		me_end_if_1

	me_else_if_12:

		cmp.w	#3,dir			;IF dir(a)=3 then
		bne		me_else_if_13

			cmp.w	#8,erelpos_y		;IF relpos_y>5 or relpos_y<5 then
			beq		me_else_121


				addq.w	#1,y

				bra		me_end_if_1

		me_else_121:

			move.w bomberd2::map_height,d0
			move.w	eblock_y,d2
			cmp.w	d0,d2		;IF block_y=9
			beq		me_if_1211
			move.w	eblock_x,d0		;or board((block_x)*10+block_y+1)<>0
			move.w	eblock_y,d1
			addq.w	#1,d1
			bsr		enemy1_check_pass
			cmp.w	#0,d2
			beq	me_if_1211
			
				addq.w	#1,y
				bra		me_end_if_1

			me_if_1211:

				move.w	#1,dir
				bra		me_end_if_1

	me_else_if_13:

		cmp.w	#4,dir			;IF dir(a)=4 then
		bne		me_end_if_1

			cmp.w	#8,erelpos_y		;IF relpos_y>5 or relpos_y<5 then
			beq		me_else_131


				subq.w	#1,y

				bra		me_end_if_1

		me_else_131:

			cmp.w	#0,eblock_y		;IF block_y=0
			beq		me_if_1311
			move.w	eblock_x,d0		;or board((block_x)*10+block_y-1)<>0
			move.w	eblock_y,d1
			subq.w	#1,d1
			bsr		enemy1_check_pass
			cmp.w	#0,d2
			beq	me_if_1311
			
				subq.w	#1,y
				bra		me_end_if_1

			me_if_1311:

				move.w	#2,dir
				bra		me_end_if_1

me_end_if_1:

	move.w	x,(a2)
	move.w	y,(a3)
	move.w	s,(a4)
	move.w	dir,(a5)
	rts

;*******************************************Delete Enemy1
;*
;*	Delete an enemy
;*
;*	Input:	d6=number of this enemy in the enemy array
;*
;********
bomberd3@0002:
delete_enemy1:

	movem.l	d0-d4/a0-a4,-(a7)

	lea	bomberd2::enemy1_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::enemy1_y,a4
	lea	0(a4,d0.w),a4

	lea	bomberd2::enemy1_s,a2
	lea	0(a2,d0.w),a2

	lea	bomberd2::enemy1_d,a3
	lea	0(a3,d0.w),a3

	move.w	bomberd2::enemy1count,d0
	sub.w	d6,d0
	subq.w	#1,d0

	addq.w	#$02,a0
	addq.w	#$02,a4
	addq.w	#$02,a2
	addq.w	#$02,a3
denemy1_loop:

	move.w	(a0),d1
	subq.w	#$02,a0
	move.w	d1,(a0)
	addq.w	#$04,a0
	move.w	(a4),d1
	subq.w	#$02,a4
	move.w	d1,(a4)
	addq.w	#$04,a4
	move.w	(a2),d1
	subq.w	#$02,a2
	move.w	d1,(a2)
	addq.w	#$04,a2
	move.w	(a3),d1
	subq.w	#$02,a3
	move.w	d1,(a3)
	addq.w	#$04,a3

	dbra.w	d0,denemy1_loop

	subq.w	#1,bomberd2::enemy1count

	movem.l	(a7)+,d0-d4/a0-a4
	rts

;*******************************************Check Pass Block
;*
;*	Check if an enemy can pass a block
;*
;*	Input:	d0=x, d1=y
;*
;*	Output: d2=0 if cannot pass, else, can pass
;*
;********
enemy1_check_pass:
	GetBoard d2
	cmp.w	#4,d2
	beq		enemy1_yes_pass
	cmp.w	#0,d2
	beq		enemy1_yes_pass
	bra		enemy1_no_pass
enemy1_yes_pass:
	move.w	#1,d2
	rts
enemy1_no_pass:
	move.w	#0,d2
	rts

sprite_enemy11:	
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%11000000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%11110000
	dc.b	%00000010,%10111100
	dc.b	%00100111,%01110110
	dc.b	%00110011,%11100110
	dc.b	%01111000,%00001111
	dc.b	%01111110,%00111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00001100,%00000000
	dc.b	%00001000,%00000000
	dc.b	%00000010,%00000000
	dc.b	%00000001,%00000000
	dc.b	%00000000,%01110001
	dc.b	%00000001,%10000010
	dc.b	%00000110,%10000000
	dc.b	%00000010,%10100000
	dc.b	%00010001,%11010000
	dc.b	%00011100,%10011000
	dc.b	%00001111,%11111000
	dc.b	%01000111,%11010001
	dc.b	%01000001,%11000001
	dc.b	%01100000,%00000011
	dc.b	%01110000,%00000111
	dc.b	%01111000,%00001111
	dc.b	%00111110,%00111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00001100,%00000000
	dc.b	%00001110,%00000000
	dc.b	%00000110,%00000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%11111111
	dc.b	%00000001,%10001110
	dc.b	%00000111,%10000000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111100
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
bomberd3@0023:
sprite_enemy12:	
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%11000000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000011,%11100000
	dc.b	%00001110,%10110000
	dc.b	%00010111,%01110100
	dc.b	%00110001,%11100110
	dc.b	%01111000,%00001111
	dc.b	%01111110,%00111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%01000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%01000000
	dc.b	%00000011,%11100000
	dc.b	%00000110,%10110000
	dc.b	%00000010,%10100000
	dc.b	%01000101,%11010001
	dc.b	%00101100,%10011010
	dc.b	%00001001,%11111000
	dc.b	%01000111,%11010001
	dc.b	%01000001,%11000001
	dc.b	%01100000,%00000011
	dc.b	%01110000,%00000111
	dc.b	%01111000,%00001111
	dc.b	%00111110,%00111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%11000000
	dc.b	%00000001,%11000000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%11000000
	dc.b	%00000011,%11100000
	dc.b	%00001111,%11111000
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
sprite_enemy13:	
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000111,%11000000
	dc.b	%00011110,%10100000
	dc.b	%00110111,%01100010
	dc.b	%00110011,%11100110
	dc.b	%01111000,%00001111
	dc.b	%01111110,%00111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00011000
	dc.b	%00000000,%00001000
	dc.b	%00000000,%00100000
	dc.b	%00000000,%01000000
	dc.b	%01000110,%00000000
	dc.b	%00100000,%11000000
	dc.b	%00000000,%10110000
	dc.b	%00000010,%10100000
	dc.b	%00000101,%11000100
	dc.b	%00001100,%10011100
	dc.b	%00001111,%11111000
	dc.b	%01000111,%11010001
	dc.b	%01000001,%11000001
	dc.b	%01100000,%00000011
	dc.b	%01110000,%00000111
	dc.b	%01111000,%00001111
	dc.b	%00111110,%00111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00011000
	dc.b	%00000000,%00111000
	dc.b	%00000000,%00110000
	dc.b	%00000000,%11000000
	dc.b	%01111111,%10000000
	dc.b	%00111000,%11000000
	dc.b	%00000000,%11110000
	dc.b	%00000111,%11111000
	dc.b	%00011111,%11111100
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
sprite_enemy14:	
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%10000000
	dc.b	%00000001,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000110,%00110000
	dc.b	%00011110,%00111100
	dc.b	%00110110,%00110110
	dc.b	%00110011,%01100110
	dc.b	%01111000,%00001111
	dc.b	%01111110,%00111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00110000,%00000110
	dc.b	%00100000,%00000010
	dc.b	%00000110,%00110000
	dc.b	%00000010,%01100000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000011,%11100000
	dc.b	%00000100,%00010000
	dc.b	%00001101,%01011000
	dc.b	%00001111,%11111000
	dc.b	%01000111,%11010001
	dc.b	%01000001,%11000001
	dc.b	%01100000,%00000011
	dc.b	%01110000,%00000111
	dc.b	%01111000,%00001111
	dc.b	%00111110,%00111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00110000,%00000110
	dc.b	%00111100,%00011110
	dc.b	%00001110,%10111000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%10000000
	dc.b	%00000111,%11110000
	dc.b	%00011111,%11111100
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000