;*******************************************Draw Enemy2
;*
;*	Draws the enemy2 sprite
;*
;*	Input:	a2=points to x-coordinate in array
;*		a3=points to y-coordinate in array
;*		a4=points to current sprite information
;*
;********
bomberd3@0008:
draw_enemy2:					;draw the enemy on the screen
	move.w	(a2),d4
	move.w	(a3),d5
	move.w	(a4),d0
	cmp.w	#50,d0					;if the current sprite is above or = 50, the enemy
	bcc		draw_enemy2_explosion	;has been destroyed, draw enemy explosion

	sub.w	#8,d4
	sub.w	#8,d5
	cmp.w	#0,d0
	beq		den2_s1
	cmp.w	#1,d0
	beq		den2_s2
	cmp.w	#2,d0
	beq		den2_s3
	cmp.w	#3,d0
	beq		den2_s4
	cmp.w	#4,d0
	beq		den2_s5
	cmp.w	#5,d0
	beq		den2_s6
	cmp.w	#6,d0
	beq		den2_s7
	cmp.w	#7,d0
	beq		den2_s8
	cmp.w	#8,d0
	beq		den2_s9
	cmp.w	#9,d0
	beq		den2_s10
	rts

den2_s1:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy21,d4,d5,#16
	rts

den2_s2:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy22,d4,d5,#16
	rts

den2_s3:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy23,d4,d5,#16
	rts

den2_s4:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy24,d4,d5,#16
	rts

den2_s5:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy25,d4,d5,#16
	rts

den2_s6:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy26,d4,d5,#16
	rts

den2_s7:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy27,d4,d5,#16
	rts

den2_s8:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy28,d4,d5,#16
	rts

den2_s9:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy29,d4,d5,#16
	rts

den2_s10:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_enemy210,d4,d5,#16
	rts

draw_enemy2_explosion:
	cmp.w	#50,d0				;the explosion is completed, delete the enemy
	beq		delete_enemy2
	subq.w	#8,d4
	sub.w	#14,d5
	cmp.w	#64,d0
	beq		draw_enemy_exp1
	cmp.w	#62,d0
	beq		draw_enemy_exp2
	cmp.w	#60,d0
	beq		draw_enemy_exp3
	cmp.w	#58,d0
	beq		draw_enemy_exp4
	cmp.w	#56,d0
	beq		draw_enemy_exp5
	cmp.w	#54,d0
	beq		draw_enemy_exp6
	cmp.w	#52,d0
	beq		draw_enemy_exp7
	cmp.w	#63,d0
	beq		draw_enemy_exp1
	cmp.w	#61,d0
	beq		draw_enemy_exp2
	cmp.w	#59,d0
	beq		draw_enemy_exp3
	cmp.w	#57,d0
	beq		draw_enemy_exp4
	cmp.w	#55,d0
	beq		draw_enemy_exp5
	cmp.w	#53,d0
	beq		draw_enemy_exp6
	cmp.w	#51,d0
	beq		draw_enemy_exp7
	rts

;*******************************************Add Enemy2
;*
;*	Add a new enemy2
;*
;*	Input:	d0=x-coordinate of new enemy2 in blocks
;*		d1=y-coordinate of new enemy2 in blocks
;*
;********
bomberd3@0009:
add_enemy2:
	move.w	d0,x
	move.w	d1,y
	movem.l	d0-d3/a0,-(a7)

	lea	bomberd2::enemy2_x,a0		;Set enemy x
	move.w  bomberd2::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::enemy2_y,a0		;Set enemy y
	move.w  bomberd2::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::enemy2_d,a0		;Set enemy d
	move.w  bomberd2::enemy2count,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	Random	#4,d3
	addq.w	#1,d3
	move.w	d3,(a0)

	lea	bomberd2::enemy2_s,a0		;Set vexp s
	lea	0(a0,d2.w),a0
	move.w	#1,(a0)

	lea	bomberd2::enemy2_b,a0		;Set vexp s
	lea	0(a0,d2.w),a0
	move.w	#0,(a0)

	addq.w	#1,bomberd2::enemy2count

	movem.l	(a7)+,d0-d3/a0
	rts

;*******************************************Get Enemy 2 Stats
;*
;*	Gather pointers for a certain enemy
;*
;*	Input:	d6=the number of this enemy in the enemy arrays
;*
;*	Output:	a2=pointer to x coordinate
;*		a3=pointer to y coordinate
;*		a4=pointer to sprite info
;*		a5=pointer to enemy direction
;*
;********
bomberd3@0005:
learn_enemy2:
	lea	bomberd2::enemy2_x,a0		;Get enemy2 d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::enemy2_y,a0		;Get enemy2 d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::enemy2_s,a0		;Get enemy2 d6's s
	lea	0(a0,d2.w),a4

	lea	bomberd2::enemy2_d,a0		;Get enemy2 d6's d
	lea	0(a0,d2.w),a5

	lea	bomberd2::enemy2_b,a0		;Get enemy2 d6's d
	lea	0(a0,d2.w),a6

	rts

;*******************************************Move Enemy2
;*
;*	Move an enemy
;*
;*	Input:	a2=pointer to x coordinate
;*		a3=pointer to y coordinate
;*		a4=pointer to sprite info
;*		a5=pointer to enemy direction
;*
;********
bomberd3@0006:
move_enemy2:
	clr.l	d0
	clr.l	d1
	clr.l	d2
	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),dir
	SetExtraPosInfo x,y

	addq.w	#1,s
	cmp.w	#10,s
	bne		me2_no_reset_s
	move.w	#0,s
me2_no_reset_s:

	move.w	(a6),d3
	cmp.w	#0,d3
	beq		me2_no_b_delay
	cmp.w	#60,d3
	beq		me2_no_b_delay
	cmp.w	#62,d3
	beq		me2_no_b_delay
		subq.w	#1,(a6)
		bra		me2_end_if_1
	me2_no_b_delay:

	cmp.w	#8,erelpos_x		;IF relpos_x=5
	bne		me2_else_1
	cmp.w	#8,erelpos_y		;and relpos_y=5
	bne		me2_else_1
	Random  #5,d3			;and (RND*5=1)
	cmp.w	#1,d3
	bne	me2_else_1

		Random  #4,d3
		addq.w	#1,d3
		move.w	d3,dir

		bra		me2_end_if_1

me2_else_1:

		cmp.w	#1,dir			;IF dir(a)=1 then
		bne		me2_else_if_11

			cmp.w	#8,erelpos_x		;IF relpos_x>5 or relpos_x<5 then
			beq		me2_else_101


				subq.w	#1,x

				bra		me2_end_if_1

		me2_else_101:

			cmp.w	#0,eblock_x		;IF block_x=0
			beq	me2_if_1011
			move.w	eblock_x,d0		;or board((block_x-1)*10+block_y)<>0
			subq.w	#1,d0
			move.w	eblock_y,d1
			bsr		enemy2_check_pass
			cmp.w	#0,d2
			beq	me2_if_1011
			bsr		check_bombs_vertical
			cmp.w	#1,d3
			beq		me2_if_1011
			
				subq.w	#1,x
				bra		me2_end_if_1

			me2_if_1011:

				move.w	#4,dir
				bra		me2_end_if_1

	me2_else_if_11:

		cmp.w	#2,dir			;IF dir(a)=2 then
		bne		me2_else_if_12

			cmp.w	#8,erelpos_x		;IF relpos_x>5 or relpos_x<5 then
			beq		me2_else_111


				addq.w	#1,x

				bra		me2_end_if_1

		me2_else_111:

			move.w	bomberd2::map_width,d0
			move.w	eblock_x,d1
			cmp.w		d0,d1			;IF block_x=12
			beq		me2_if_1111
			move.w	eblock_x,d0		;or board((block_x+1)*10+block_y)<>0
			addq.w	#1,d0
			move.w	eblock_y,d1
			bsr		enemy2_check_pass
			cmp.w	#0,d2
			beq	me2_if_1111
			bsr		check_bombs_vertical
			cmp.w	#1,d3
			beq		me2_if_1111
			
				addq.w	#1,x
				bra		me2_end_if_1

			me2_if_1111:

				move.w	#3,dir
				bra		me2_end_if_1

	me2_else_if_12:

		cmp.w	#3,dir			;IF dir(a)=3 then
		bne		me2_else_if_13

			cmp.w	#8,erelpos_y		;IF relpos_y>5 or relpos_y<5 then
			beq		me2_else_121


				addq.w	#1,y

				bra		me2_end_if_1

		me2_else_121:

			move.w  bomberd2::map_height,d0
			move.w  eblock_y,d1
			cmp.w	d0,d1			;IF block_y=9
			beq		me2_if_1211
			move.w	eblock_x,d0		;or board((block_x)*10+block_y+1)<>0
			move.w	eblock_y,d1
			addq.w	#1,d1
			bsr		enemy2_check_pass
			cmp.w	#0,d2
			beq	me2_if_1211
			bsr		check_bombs_horizontal
			cmp.w	#1,d3
			beq		me2_if_1211
			
				addq.w	#1,y
				bra		me2_end_if_1

			me2_if_1211:

				move.w	#1,dir
				bra		me2_end_if_1

	me2_else_if_13:

		cmp.w	#4,dir			;IF dir(a)=4 then
		bne		me2_end_if_1

			cmp.w	#8,erelpos_y		;IF relpos_y>5 or relpos_y<5 then
			beq		me2_else_131


				subq.w	#1,y

				bra		me2_end_if_1

		me2_else_131:

			cmp.w	#0,eblock_y		;IF block_y=0
			beq		me2_if_1311
			move.w	eblock_x,d0		;or board((block_x)*10+block_y-1)<>0
			move.w	eblock_y,d1
			subq.w	#1,d1
			bsr		enemy2_check_pass
			cmp.w	#0,d2
			beq	me2_if_1311
			bsr		check_bombs_horizontal
			cmp.w	#1,d3
			beq		me2_if_1311

				subq.w	#1,y
				bra		me2_end_if_1

			me2_if_1311:

				move.w	#2,dir
				bra		me2_end_if_1

me2_end_if_1:

	move.w	x,(a2)
	move.w	y,(a3)
	move.w	s,(a4)
	move.w	dir,(a5)
	rts

;*******************************************Delete enemy2
;*
;*	Delete an enemy
;*
;*	Input:	d6=number of this enemy in the enemy array
;*
;********
bomberd3@0007:
delete_enemy2:
	
	movem.l	d0-d4/a0-a4,-(a7)

	lea	bomberd2::enemy2_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::enemy2_y,a4
	lea	0(a4,d0.w),a4

	lea	bomberd2::enemy2_s,a2
	lea	0(a2,d0.w),a2

	lea	bomberd2::enemy2_d,a3
	lea	0(a3,d0.w),a3

	lea	bomberd2::enemy2_b,a1
	lea	0(a1,d0.w),a1

	move.w	bomberd2::enemy2count,d0
	sub.w	d6,d0
	subq.w	#1,d0

	addq.w	#$02,a0
	addq.w	#$02,a4
	addq.w	#$02,a2
	addq.w	#$02,a3
	addq.w	#$02,a1
denemy2_loop:
	
	move.w	(a0),d1
	subq.w	#$02,a0
	move.w	d1,(a0)
	addq.w	#$04,a0
	move.w	(a4),d1
	subq.w	#$02,a4
	move.w	d1,(a4)
	addq.w	#$04,a4
	move.w	(a2),d1
	subq.w	#$02,a2
	move.w	d1,(a2)
	addq.w	#$04,a2
	move.w	(a3),d1
	subq.w	#$02,a3
	move.w	d1,(a3)
	addq.w	#$04,a3
	move.w	(a1),d1
	subq.w	#$02,a1
	move.w	d1,(a1)
	addq.w	#$04,a1

	dbra.w	d0,denemy2_loop

	subq.w	#1,bomberd2::enemy2count

	movem.l	(a7)+,d0-d4/a0-a4
	rts

;*******************************************Check Pass Block
;*
;*	Check if an enemy can pass a block
;*
;*	Input:	d0=x, d1=y
;*
;*	Output: d2=0 if cannot pass, else, can pass
;*
;********
enemy2_check_pass:
	GetBoard d2
	cmp.w	#4,d2
	beq		enemy2_yes_pass
	cmp.w	#0,d2
	bne		enemy2_no_pass
	bra		enemy2_yes_pass
enemy2_yes_pass:
	move.w	#1,d2
	rts
enemy2_no_pass:
	move.w	#0,d2
	rts

sprite_enemy21:
	dc.b	%00000011,%10000000
	dc.b	%00000111,%11000000
	dc.b	%00000100,%01000000
	dc.b	%00000100,%01000000
	dc.b	%00000100,%01000000
	dc.b	%00000100,%01000000
	dc.b	%00000100,%01000000
	dc.b	%00000100,%01000000
	dc.b	%00000100,%01000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00000011,%10000000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000011,%10000000
sprite_enemy22:
	dc.b	%00000011,%11000000
	dc.b	%00000100,%01110000
	dc.b	%00001000,%00011000
	dc.b	%00001000,%00101000
	dc.b	%00010000,%00101000
	dc.b	%00010000,%01101000
	dc.b	%00100000,%01101000
	dc.b	%00111000,%01101000
	dc.b	%00111110,%11101000
	dc.b	%00111110,%11011000
	dc.b	%00111110,%11010000
	dc.b	%00111110,%11010000
	dc.b	%00111110,%10100000
	dc.b	%00011110,%10100000
	dc.b	%00011111,%01000000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00001110,%00000000
	dc.b	%00011111,%00000000
	dc.b	%00000111,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00001000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00010000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%11000000
	dc.b	%00000111,%11110000
	dc.b	%00001111,%11111000
	dc.b	%00001111,%11111000
	dc.b	%00011111,%11111000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11110000
	dc.b	%00111111,%11110000
	dc.b	%00111111,%11100000
	dc.b	%00011111,%11100000
	dc.b	%00011111,%11000000
	dc.b	%00000011,%10000000
sprite_enemy23:
	dc.b	%00000001,%10000000
	dc.b	%00000111,%11100000
	dc.b	%00001000,%11110000
	dc.b	%00010000,%00011000
	dc.b	%00100000,%00000100
	dc.b	%00100000,%00010100
	dc.b	%01000000,%00010100
	dc.b	%01100000,%00010100
	dc.b	%01100000,%00010100
	dc.b	%01110000,%00010100
	dc.b	%01111000,%00001100
	dc.b	%01111000,%00101000
	dc.b	%00111010,%01011000
	dc.b	%00111001,%10110000
	dc.b	%00011000,%01100000
	dc.b	%00001111,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000111,%00000000
	dc.b	%00001001,%10000000
	dc.b	%00011100,%01100000
	dc.b	%00011110,%11100000
	dc.b	%00111101,%11100000
	dc.b	%00011101,%11100000
	dc.b	%00011011,%11100000
	dc.b	%00001011,%11100000
	dc.b	%00000011,%11100000
	dc.b	%00000011,%11000000
	dc.b	%00000001,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000100,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%10000000
	dc.b	%00000111,%11100000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11110000
	dc.b	%00011111,%11100000
	dc.b	%00001111,%11000000
bomberd3@0024:
sprite_enemy24:
	dc.b	%00000001,%11100000
	dc.b	%00000110,%00110000
	dc.b	%00001000,%00011000
	dc.b	%00010000,%00001100
	dc.b	%00100000,%01000110
	dc.b	%00100001,%00001010
	dc.b	%01100010,%00001010
	dc.b	%01110010,%00001010
	dc.b	%01110100,%00001010
	dc.b	%01110100,%00001010
	dc.b	%01110100,%00000110
	dc.b	%01110100,%00010100
	dc.b	%00110100,%01101000
	dc.b	%00011011,%10010000
	dc.b	%00001100,%01100000
	dc.b	%00000111,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%11000000
	dc.b	%00000111,%11100000
	dc.b	%00000011,%10000000
	dc.b	%00011000,%00110000
	dc.b	%00011100,%11110000
	dc.b	%00011001,%11110000
	dc.b	%00001001,%11110000
	dc.b	%00000011,%11110000
	dc.b	%00000011,%11110000
	dc.b	%00000011,%11110010
	dc.b	%00000011,%11100000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%01000000
	dc.b	%00000001,%11100000
	dc.b	%00000111,%11110000
	dc.b	%00001111,%11111000
	dc.b	%00011111,%11111100
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111100
	dc.b	%00111111,%11111000
	dc.b	%00011111,%11110000
	dc.b	%00001111,%11100000
	dc.b	%00000111,%11000000
sprite_enemy25:
	dc.b	%00000011,%11000000
	dc.b	%00001110,%01110000
	dc.b	%00011000,%00011000
	dc.b	%00110000,%00000100
	dc.b	%01100000,%11100010
	dc.b	%01110010,%00001001
	dc.b	%11110100,%00000101
	dc.b	%11110100,%00000101
	dc.b	%11101000,%00000101
	dc.b	%11101000,%00000101
	dc.b	%11101000,%00001010
	dc.b	%01101000,%00001010
	dc.b	%00110100,%00110100
	dc.b	%00011011,%11001000
	dc.b	%00001100,%00110000
	dc.b	%00000111,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%10000000
	dc.b	%00000011,%11100000
	dc.b	%00001001,%00011000
	dc.b	%00011100,%00000100
	dc.b	%00001001,%11110010
	dc.b	%00000011,%11111000
	dc.b	%00000011,%11111000
	dc.b	%00000111,%11111000
	dc.b	%00000111,%11111000
	dc.b	%00000111,%11110000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%11000000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00000111,%11000000
sprite_enemy26:
	dc.b	%00000011,%11000000
	dc.b	%00001100,%00110000
	dc.b	%00010000,%00001000
	dc.b	%00100000,%00000100
	dc.b	%01000011,%11000010
	dc.b	%11001100,%00110011
	dc.b	%11010000,%00001011
	dc.b	%11010000,%00001011
	dc.b	%10100000,%00000101
	dc.b	%10100000,%00000101
	dc.b	%01010000,%00001010
	dc.b	%01010000,%00001010
	dc.b	%00101100,%00110100
	dc.b	%00010011,%11001000
	dc.b	%00001100,%00110000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000010,%01000000
	dc.b	%00001110,%01110000
	dc.b	%00011100,%00111000
	dc.b	%00110000,%00001100
	dc.b	%00100011,%11000100
	dc.b	%00001111,%11110000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00001111,%11110000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%11000000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00000011,%11000000
sprite_enemy27:
	dc.b	%00000011,%11000000
	dc.b	%00001110,%01110000
	dc.b	%00011000,%00011000
	dc.b	%00100000,%00001100
	dc.b	%01000111,%00000110
	dc.b	%10010000,%01001110
	dc.b	%10100000,%00101111
	dc.b	%10100000,%00101111
	dc.b	%10100000,%00010111
	dc.b	%10100000,%00010111
	dc.b	%01010000,%00010111
	dc.b	%01010000,%00010110
	dc.b	%00101100,%00101100
	dc.b	%00010011,%11011000
	dc.b	%00001100,%00110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%10000000
	dc.b	%00000111,%11000000
	dc.b	%00011000,%10010000
	dc.b	%00100000,%00111000
	dc.b	%01001111,%10010000
	dc.b	%00011111,%11000000
	dc.b	%00011111,%11000000
	dc.b	%00011111,%11100000
	dc.b	%00011111,%11100000
	dc.b	%00001111,%11100000
	dc.b	%00001111,%11100000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%11000000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00000011,%11100000
sprite_enemy28:
	dc.b	%00000111,%10000000
	dc.b	%00001100,%01100000
	dc.b	%00011000,%00010000
	dc.b	%00110000,%00001000
	dc.b	%01100010,%00000100
	dc.b	%01010000,%10000100
	dc.b	%01010000,%01000110
	dc.b	%01010000,%01001110
	dc.b	%01010000,%00101110
	dc.b	%01010000,%00101110
	dc.b	%01100000,%00101110
	dc.b	%00101000,%00101110
	dc.b	%00010110,%00101100
	dc.b	%00001001,%11011000
	dc.b	%00000110,%00110000
	dc.b	%00000011,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%10000000
	dc.b	%00000111,%11100000
	dc.b	%00000001,%11000000
	dc.b	%00001100,%00011000
	dc.b	%00001111,%00111000
	dc.b	%00001111,%10011000
	dc.b	%00001111,%10010000
	dc.b	%00001111,%11000000
	dc.b	%00001111,%11000000
	dc.b	%01001111,%11000000
	dc.b	%00000111,%11000000
	dc.b	%00000001,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000010,%00000000
	dc.b	%00000111,%10000000
	dc.b	%00001111,%11100000
	dc.b	%00011111,%11110000
	dc.b	%00111111,%11111000
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00001111,%11111000
	dc.b	%00000111,%11110000
	dc.b	%00000011,%11100000
sprite_enemy29:
	dc.b	%00000001,%10000000
	dc.b	%00000111,%11100000
	dc.b	%00001111,%00010000
	dc.b	%00011000,%00001000
	dc.b	%00100000,%00000100
	dc.b	%00101000,%00000100
	dc.b	%00101000,%00000010
	dc.b	%00101000,%00000110
	dc.b	%00101000,%00000110
	dc.b	%00101000,%00001110
	dc.b	%00110000,%00011110
	dc.b	%00010100,%00011110
	dc.b	%00011010,%01011100
	dc.b	%00001101,%10011100
	dc.b	%00000110,%00011000
	dc.b	%00000011,%11110000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%11100000
	dc.b	%00000001,%10010000
	dc.b	%00000110,%00111000
	dc.b	%00000111,%01111000
	dc.b	%00000111,%10111100
	dc.b	%00000111,%10111000
	dc.b	%00000111,%11011000
	dc.b	%00000111,%11010000
	dc.b	%00000111,%11000000
	dc.b	%00000011,%11000000
	dc.b	%00000001,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00100000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%10000000
	dc.b	%00000111,%11100000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%00011111,%11111110
	dc.b	%00011111,%11111100
	dc.b	%00001111,%11111100
	dc.b	%00000111,%11111000
	dc.b	%00000011,%11110000
sprite_enemy210:
	dc.b	%00000011,%11000000
	dc.b	%00001110,%00100000
	dc.b	%00011000,%00010000
	dc.b	%00010100,%00010000
	dc.b	%00010100,%00001000
	dc.b	%00010110,%00001000
	dc.b	%00010110,%00000100
	dc.b	%00010110,%00011100
	dc.b	%00010111,%01111100
	dc.b	%00011011,%01111100
	dc.b	%00001011,%01111100
	dc.b	%00001011,%01111100
	dc.b	%00000101,%01111100
	dc.b	%00000101,%01111000
	dc.b	%00000010,%11111000
	dc.b	%00000001,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%11000000
	dc.b	%00000011,%11000000
	dc.b	%00000001,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%01110000
	dc.b	%00000000,%11111000
	dc.b	%00000000,%11100000
	dc.b	%00000000,%00000000
	dc.b	%00010000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%11000000
	dc.b	%00001111,%11100000
	dc.b	%00011111,%11110000
	dc.b	%00011111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%00011111,%11111000
	dc.b	%00011111,%11111100
	dc.b	%00011111,%11111100
	dc.b	%00011111,%11111100
	dc.b	%00011111,%11111100
	dc.b	%00001111,%11111100
	dc.b	%00001111,%11111100
	dc.b	%00000111,%11111100
	dc.b	%00000111,%11111000
	dc.b	%00000011,%11111000
	dc.b	%00000001,%11000000