;*******************************************Handle mine
;*
;*	called by mainloop to do processes on this mine
;*
;*	Input:	d6=the # of this bonb in the mine array
;*
;********
bomberd4@0018:
handle_mine:
	
	bsr	learn_mine
	move.w	t,t
	move.w	s,d2

	cmp.w	#0,t
	beq		end_handle_mine
	subq.w	#1,s
	cmp.w	#1,t
	beq		mine_hiding
	cmp.w	#0,s
	beq		explode_mine
	bra		end_handle_mine
mine_hiding:
	cmp.w	#0,s
	bne		end_handle_mine
	move.w	#0,t
end_handle_mine:
	move.w	s,(a4)
	move.w	t,(a5)
	rts

learn_mine:
	lea	bomberd2::mine_x,a0		;Get mine d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::mine_y,a0		;Get mine d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::mine_s,a0		;Get mine d6's s
	lea	0(a0,d2.w),a4

	lea	bomberd2::mine_t,a0		;Get mine d6's es
	lea	0(a0,d2.w),a5


	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),t

	SetExtraPosInfo x,y

	subq.w	#8,x
	subq.w	#8,y
	rts

bomberd4@0019:
draw_mine:
	bsr	learn_mine
		;draw the mine sprite
	cmp.w	#0,t
	beq		end_draw_mine

	clr.l	d0
	move.w	s,d0
	divu.w	#2,d0
	swap.l	d0
	clr.w	d0
	swap.l	d0
	divu.w	#2,d0
	swap.l	d0

	cmp.w	#1,d0
	beq		draw_m

end_draw_mine:
	rts

draw_m:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_mine,x,y,#16
	rts

;*******************************************Explode mine
;*
;*	Explodes and Deletes a mine from the mine array
;*
;*	Input:	d6=the # of this mine in the mine array
;*
;********
bomberd4@001A:
explode_mine:
	movem.l	d0-d3/a0-a3,-(a7)

	move.w	bomberd2::bomb_exp_len,d0
	move.w	d0,explen

		;add explosions downward
	clr.w	d2
	move.w	eblock_y,d1
	addq.w	#1,d1
	move.w	#0,tmp
dm_add_vexp_down_loop:
	move.w	eblock_x,d0
	GetBoard d3
	cmp.w	#2,d3					;I hit undestr. wall
	beq		dm_exit_add_vexp_down_loop
	cmp.w	bomberd2::map_height,d1
	bhi		dm_exit_add_vexp_down_loop
	cmp.w	explen,d2
	beq		dm_exit_add_vexp_down_loop
	cmp.w	#1,d3						;I hit a destructable wall
	beq		dm_exit_add_vexp_down_loop_w_score_inc
	cmp.w	#3,d3
	beq		dm_add_vexp_down_loop_got_mine
	cmp.w	#4,d3
	beq		dm_add_vexp_down_loop_got_mine
	cmp.w	#0,d3
	bne		dm_exit_add_vexp_down_loop
dm_add_vexp_down_loop_got_mine:
	move.w	d0,x
	move.w	d1,y
	bsr		add_vexp
	cmp.w	#3,d3
	beq		dm_exit_add_vexp_down_loop		;I hit a mine
	addq.w	#1,d1
	addq.w	#1,d2
	bra		dm_add_vexp_down_loop
dm_exit_add_vexp_down_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
dm_exit_add_vexp_down_loop:

		;add explosions upwards
	clr.w	d2
	move.w	#1,tmp
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	subq.w	#1,d1
	cmp.w	#0,eblock_y
	beq		dm_exit_add_vexp_up_loop
dm_add_vexp_up_loop:
	GetBoard d3
	cmp.w	#2,d3
	beq		dm_exit_add_vexp_up_loop
	cmp.w	explen,d2
	beq		dm_exit_add_vexp_up_loop
	cmp.w	#1,d3
	beq		dm_exit_add_vexp_up_loop_w_score_inc
	cmp	#3,d3
	beq		dm_add_vexp_up_loop_got_mine
	cmp	#4,d3
	beq		dm_add_vexp_up_loop_got_mine
	cmp.w	#0,d3
	bne		dm_exit_add_vexp_up_loop
dm_add_vexp_up_loop_got_mine:
	move.w	d1,y
	move.w	d0,x
	bsr		add_vexp
	cmp.w	#3,d3
	beq		dm_exit_add_vexp_up_loop		;I hit a mine
	addq.w	#1,d2
	cmp.w	#0,d1
	beq		dm_exit_add_vexp_up_loop
	subq.w	#1,d1
	bra		dm_add_vexp_up_loop
dm_exit_add_vexp_up_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
dm_exit_add_vexp_up_loop:

		;add explosions to the right
	clr.w	d2
	move.w	eblock_x,d0
	addq.w	#1,d0
	move.w	#0,tmp
dm_add_hexp_right_loop:
	move.w	eblock_y,d1
	GetBoard d3
	cmp.w	#2,d3
	beq		dm_exit_add_hexp_right_loop
	cmp.w	bomberd2::map_width,d0
	bhi		dm_exit_add_hexp_right_loop
	cmp.w	explen,d2
	beq		dm_exit_add_hexp_right_loop
	cmp.w	#1,d3
	beq		dm_exit_add_hexp_right_loop_w_score_inc
	cmp.w	#3,d3
	beq		dm_add_hexp_right_loop_got_mine
	cmp.w	#4,d3
	beq		dm_add_hexp_right_loop_got_mine
	cmp.w	#0,d3
	bne		dm_exit_add_hexp_right_loop
dm_add_hexp_right_loop_got_mine:
	move.w	d0,x
	move.w	d1,y
	bsr		add_hexp
	cmp.w	#3,d3
	beq		dm_exit_add_hexp_right_loop		;I hit a mine
	addq.w	#1,d0
	addq.w	#1,d2
	bra		dm_add_hexp_right_loop
dm_exit_add_hexp_right_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
dm_exit_add_hexp_right_loop:

		;add explosions to the left
	clr.w	d2
	move.w	#1,tmp
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	subq.w	#1,d0
	cmp.w	#0,eblock_x
	beq		dm_exit_add_hexp_left_loop
dm_add_hexp_left_loop:
	GetBoard d3
	cmp.w	#2,d3
	beq		dm_exit_add_hexp_left_loop
	cmp.w	explen,d2
	beq		dm_exit_add_hexp_left_loop
	cmp.w	#1,d3
	beq		dm_exit_add_hexp_left_loop_w_score_inc
	cmp.w	#3,d3
	beq		dm_add_hexp_left_loop_got_mine
	cmp.w	#4,d3
	beq		dm_add_hexp_left_loop_got_mine
	cmp.w	#0,d3
	bne		dm_exit_add_hexp_left_loop
dm_add_hexp_left_loop_got_mine:
	move.w	d1,y
	move.w	d0,x
	bsr		add_hexp
	cmp.w	#3,d3
	beq		dm_exit_add_hexp_left_loop		;I hit a mine
	addq.w	#1,d2
	cmp.w	#0,d0
	beq		dm_exit_add_hexp_left_loop
	subq.w	#1,d0
	bra		dm_add_hexp_left_loop
dm_exit_add_hexp_left_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
dm_exit_add_hexp_left_loop:

	move.w	eblock_x,x	;add xexp to where the mine was
	move.w	eblock_y,y
	bsr		add_xexp
	movem.l	(a7)+,d0-d3/a0-a3
	bsr		delete_mine
	rts

;*******************************************Delete mine
;*
;*	Deletes a mine from the mine array
;*
;*	Input:	d6=the # of this mine in the mine array
;*
;********
bomberd4@001B:
delete_mine:
	movem.l	d0-d3/a0-a6,-(a7)
	bsr		learn_mine
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoardL	#0

	lea	bomberd2::mine_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::mine_y,a1
	lea	0(a1,d0.w),a1

	lea	bomberd2::mine_s,a2
	lea	0(a2,d0.w),a2

	lea	bomberd2::mine_t,a3
	lea	0(a3,d0.w),a3


	move.w	bomberd2::minecount,d1
	sub.w	d6,d1
	subq.w	#1,d1

		;shift the mine array to cover the deleted mine
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
	addq.w	#$02,a3
dm_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2
	move.w	(a3),d0
	subq.w	#$02,a3
	move.w	d0,(a3)
	addq.w	#$04,a3

	dbra.w	d1,dm_loop

	subq.w	#1,bomberd2::minecount

	movem.l	(a7)+,d0-d3/a0-a6
	rts

;*******************************************Add mine
;*
;*	called by mainloop to do processes on this mine
;*
;*	Input:	x=the x-coordinate of the new mine in blocks
;*		y=the y-coordinate of the new mine in blocks
;*
;********
bomberd4@001C:
add_mine:
	movem.l	d0-d2/a0,-(a7)

	move.w	x,d0
	move.w	y,d1

	GetBoard d2
	cmp.w	#1,d2
	beq	cancel_add_mine

	lea	bomberd2::mine_x,a0		;Set mine x
	move.w  bomberd2::minecount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::mine_y,a0		;Set mine y
	move.w  bomberd2::minecount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	move.w	x,d0
	move.w	y,d1
	SetBoardL	#4

	lea	bomberd2::mine_s,a0		;Set mine s
	move.w  bomberd2::minecount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomberd2::mineaddlife,(a0)

	lea	bomberd2::mine_t,a0		;Set mine t
	move.w  bomberd2::minecount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#1,(a0)

	addq.w	#1,bomberd2::minecount

cancel_add_mine:
	movem.l	(a7)+,d0-d2/a0
	rts




;mine sprite
bomberd4@0035:
sprite_mine:	
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00001111,%11110000
	dc.b	%00111111,%11111100
	dc.b	%01111110,%11111110
	dc.b	%11111101,%11111111
	dc.b	%11111100,%01111111
	dc.b	%11000111,%11111111
	dc.b	%11000011,%11000111
	dc.b	%11100011,%10000111
	dc.b	%11110011,%10011111
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00001111,%11110000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00001111,%11110000
	dc.b	%00111110,%01111100
	dc.b	%01100010,%01001110
	dc.b	%11000111,%10100111
	dc.b	%11111110,%10111111
	dc.b	%10011011,%11000011
	dc.b	%10011101,%10111011
	dc.b	%11001101,%00111011
	dc.b	%11100001,%00100111
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00001111,%11110000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00001111,%11110000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00001111,%11110000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
