;*******************************************Handle Verticle Explosion
;*
;*	This functions handles an vertical explosion(looks like |)
;*
;*	Input	d6=the vexp explosion # in the array
;*
;*********
bomberd4@0010:
handle_vexp:
	bsr	learn_vexp
	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_vexp
	move.w	s,(a4)
	rts

learn_vexp:
	lea	bomberd2::vexp_x,a0		;Get vexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::vexp_y,a0		;Get vexp d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::vexp_s,a0		;Get vexp d6's s
	lea	0(a0,d2.w),a4

	lea	bomberd2::vexp_o,a0		;Get vexp d6's s
	lea	0(a0,d2.w),a5

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),o

	subq.w	#8,x
	subq.w	#8,y
	rts

bomberd4@0011:
draw_vexp:
	bsr	learn_vexp
		;draw the vexp sprite
	cmp.w	#1,s
	beq		hve_s1
	cmp.w	#2,s
	beq		hve_s2
	cmp.w	#3,s
	beq		hve_s3
	cmp.w	#4,s
	beq		hve_s4
	cmp.w	#5,s
	beq		hve_s3
	cmp.w	#6,s
	beq		hve_s2
	cmp.w	#7,s
	beq		hve_s1
	;bra		delete_vexp
	rts

hve_s1:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_vexp1,x,y,#16
	rts

hve_s2:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_vexp2,x,y,#16
	rts

hve_s3:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_vexp3,x,y,#16
	rts

hve_s4:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_vexp4,x,y,#16
	rts

;*******************************************Delete Verticle Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the vexp array
;*
;*********
bomberd4@0012:
delete_vexp:

	movem.l	d0/a0-a3,-(a7)

	lea	bomberd2::vexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::vexp_y,a1
	lea	0(a1,d0.w),a1

	lea	bomberd2::vexp_s,a2
	lea	0(a2,d0.w),a2

	lea	bomberd2::vexp_o,a3
	lea	0(a3,d0.w),a3

	move.w	bomberd2::vexpcount,d1
	sub.w	d6,d1
	cmp.w	#0,d1
	beq		dve_loop_exit
	subq.w	#1,d1

		;this code shifts the array one less starting at the posiion of this sprite
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
	addq.w	#$02,a3
dve_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2
	move.w	(a3),d0
	subq.w	#$02,a3
	move.w	d0,(a3)
	addq.w	#$04,a3

	dbra.w	d1,dve_loop

dve_loop_exit:
	subq.w	#1,bomberd2::vexpcount

	movem.l	(a7)+,d0/a0-a3
	rts

;*******************************************Add Verticle Explosion
;*
;*	This functions adds a verticle explosion to the vexp array
;*
;*	Input:	x=x coordinate(in squares) of the new vexp
;*		y=y coordinate(in squares) of the new vexp
;*		o=owner
;*
;*********
bomberd4@0013:
add_vexp:
	movem.l	d0-d4/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	SetBoardL #0
	cmp.w	#3,d2
	bne		add_vexp_no_bomb

	mulu.w	#16,d0
	addq.w	#8,d0
	mulu.w	#16,d1
	addq.w	#8,d1

				;this code checks if this explosion
				;occurs on top of a bomb, wherein
				;it will set the bomb off
			move.w	bomberd2::bombcount,d4
			cmp.w	#0,d4
			ble		add_vexp_end_bomb_loop_1
			subq.w	#1,d4
		add_vexp_bomb_loop_1:
			move.w	d4,d3

			lea	bomberd2::bomb_x,a0		;Set vexp x
			mulu.w	#2,d3
			lea	0(a0,d3.w),a0
			move.w	(a0),d2

			cmp.w	d2,d0
			bne		add_vexp_bomb_nope

				lea	bomberd2::bomb_y,a0		;Set vexp y
				lea	0(a0,d3.w),a0
				move.w	(a0),d2

				cmp.w	d2,d1
				bne		add_vexp_bomb_nope

					lea	bomberd2::bomb_es,a0		;Set vexp es
					lea	0(a0,d3.w),a0
					move.w	#2,(a0)

			add_vexp_bomb_nope:

			dbra.w	d4,add_vexp_bomb_loop_1
		add_vexp_end_bomb_loop_1:
		bra	cancel_add_vexp

add_vexp_no_bomb:

	lea	bomberd2::vexp_x,a0		;Set vexp x
	move.w  bomberd2::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::vexp_y,a0		;Set vexp y
	move.w  bomberd2::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::vexp_s,a0		;Set vexp s
	move.w  bomberd2::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomberd2::explife,(a0)

	lea	bomberd2::vexp_o,a0		;Set vexp s
	move.w  bomberd2::vexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	o,(a0)

	addq.w	#1,bomberd2::vexpcount

cancel_add_vexp:
	movem.l	(a7)+,d0-d4/a0
	rts







;the verticle explosion
sprite_vexp1:	
	dc.b	%00001100,%01110000
	dc.b	%00011100,%00100000
	dc.b	%00101110,%00101000
	dc.b	%00011100,%00110000
	dc.b	%01011110,%01101000
	dc.b	%00011110,%11100000
	dc.b	%00001110,%01101000
	dc.b	%00101110,%01100000
	dc.b	%00001110,%01100000
	dc.b	%00001100,%01100000
	dc.b	%00101100,%01100000
	dc.b	%00001100,%01000000
	dc.b	%00001110,%01001000
	dc.b	%01000110,%01100000
	dc.b	%00000110,%01100000
	dc.b	%00001110,%01100000
	dc.b	%00000011,%10000000
	dc.b	%00000011,%11000000
	dc.b	%00000001,%11000000
	dc.b	%00000011,%11000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%00000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00000011,%10000000
	dc.b	%00000011,%10000000
	dc.b	%00000011,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00000001,%10000000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11100000
	dc.b	%00101111,%11101000
	dc.b	%00011111,%11110000
	dc.b	%01011111,%11101000
	dc.b	%00011111,%11100000
	dc.b	%00001111,%11101000
	dc.b	%00101111,%11100000
	dc.b	%00001111,%11100000
	dc.b	%00001111,%11100000
	dc.b	%00101111,%11100000
	dc.b	%00001111,%11000000
	dc.b	%00001111,%11001000
	dc.b	%01000111,%11100000
	dc.b	%00000111,%11100000
	dc.b	%00001111,%11100000

sprite_vexp2:	
	dc.b	%00011100,%00111100
	dc.b	%00111100,%00011000
	dc.b	%01111110,%00011010
	dc.b	%00111100,%00011100
	dc.b	%11111100,%00111010
	dc.b	%00111100,%01111000
	dc.b	%00011000,%00111010
	dc.b	%01111000,%00011000
	dc.b	%00011110,%00011000
	dc.b	%00011100,%00011000
	dc.b	%01111100,%00111000
	dc.b	%00001000,%00110000
	dc.b	%00011000,%00111000
	dc.b	%01001000,%00110000
	dc.b	%00001100,%00011000
	dc.b	%00011101,%00011000
	dc.b	%00000010,%01000000
	dc.b	%00000011,%11100000
	dc.b	%00000001,%01100000
	dc.b	%00000010,%01100000
	dc.b	%00000010,%01000000
	dc.b	%00000010,%10000000
	dc.b	%00000110,%11000000
	dc.b	%00000111,%01100000
	dc.b	%00000000,%01100000
	dc.b	%00000010,%01100000
	dc.b	%00000010,%01000000
	dc.b	%00000110,%01000000
	dc.b	%00000110,%01000000
	dc.b	%00000110,%11000000
	dc.b	%00000011,%11100000
	dc.b	%00000010,%01100000
	dc.b	%00011111,%11111100
	dc.b	%00111111,%11111000
	dc.b	%01111111,%11111010
	dc.b	%00111111,%11111100
	dc.b	%11111111,%11111010
	dc.b	%00111111,%11111000
	dc.b	%00011111,%11111010
	dc.b	%01111111,%11111000
	dc.b	%00011111,%11111000
	dc.b	%00011111,%11111000
	dc.b	%01111111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00011111,%11111000
	dc.b	%01001111,%11110000
	dc.b	%00001111,%11111000
	dc.b	%00011111,%11111000

sprite_vexp3:	
	dc.b	%00111100,%00001110
	dc.b	%00111000,%00001110
	dc.b	%01110000,%00001110
	dc.b	%00110000,%00001110
	dc.b	%11110000,%00011110
	dc.b	%10110000,%00011101
	dc.b	%00110010,%00001110
	dc.b	%01111100,%00001100
	dc.b	%00011000,%00001000
	dc.b	%00111000,%00001100
	dc.b	%01111000,%00001100
	dc.b	%00011000,%00001000
	dc.b	%00111000,%00011000
	dc.b	%01011000,%00111100
	dc.b	%01011000,%00001000
	dc.b	%00011000,%00001000
	dc.b	%00000010,%00010000
	dc.b	%00000110,%00010000
	dc.b	%00001000,%00010000
	dc.b	%00001000,%00110000
	dc.b	%00001000,%01100000
	dc.b	%00001000,%11100000
	dc.b	%00001101,%00010000
	dc.b	%00000011,%00010000
	dc.b	%00000110,%00010000
	dc.b	%00000100,%00010000
	dc.b	%00000000,%00010000
	dc.b	%00000000,%00110000
	dc.b	%00000000,%01100000
	dc.b	%00000111,%11000000
	dc.b	%00000100,%01110000
	dc.b	%00000110,%00110000
	dc.b	%00111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%11111111,%11111110
	dc.b	%10111111,%11111101
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%01011111,%11111100
	dc.b	%01011111,%11111000
	dc.b	%00011111,%11111000

sprite_vexp4:	
	dc.b	%11100000,%00000011
	dc.b	%11100000,%00000011
	dc.b	%01110000,%00000011
	dc.b	%11111100,%00000111
	dc.b	%11111000,%00000111
	dc.b	%11110000,%00001111
	dc.b	%01100000,%00001110
	dc.b	%01100000,%00000111
	dc.b	%00110000,%00000110
	dc.b	%01111100,%00000100
	dc.b	%01111000,%00000100
	dc.b	%01100000,%00000110
	dc.b	%00100000,%00000110
	dc.b	%01111000,%00000100
	dc.b	%01110000,%00001110
	dc.b	%01110000,%00001110
	dc.b	%00011000,%00001100
	dc.b	%00011000,%00111100
	dc.b	%00001111,%10001100
	dc.b	%00000010,%00001000
	dc.b	%00000100,%00001000
	dc.b	%00001000,%00010000
	dc.b	%00010000,%00010000
	dc.b	%00010000,%00011000
	dc.b	%00001000,%00111000
	dc.b	%00000010,%00011000
	dc.b	%00000110,%00001000
	dc.b	%00011100,%00001000
	dc.b	%00011000,%00011000
	dc.b	%00000000,%00011000
	dc.b	%00001000,%00000000
	dc.b	%00001000,%00000000
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
